Package: ramr
Title: Detection of Rare Aberrantly Methylated Regions in Array and NGS
        Data
Version: 1.20.0
Authors@R: 
  person(given = "Oleksii",
    family = "Nikolaienko",
    role = c("aut", "cre"),
    email = "oleksii.nikolaienko@gmail.com",
    comment = c(ORCID = "0000-0002-5910-4934"))
Description: ramr is an R package for detection of epimutations (i.e.,
  infrequent aberrant DNA methylation events)
  in large data sets obtained by methylation profiling using array or
  high-throughput methylation sequencing. In addition, package
  provides functions to visualize found aberrantly methylated regions (AMRs),
  to generate sets of all possible regions to be used as reference sets for
  enrichment analysis, and to generate biologically relevant test data sets
  for performance evaluation of AMR/DMR search algorithms.
SystemRequirements: C++20, GNU make
NeedsCompilation: yes
Depends: R (>= 4.1)
Imports: methods, data.table, Seqinfo, GenomicRanges, IRanges,
        BiocGenerics, S4Vectors, Rcpp
LinkingTo: Rcpp
Suggests: RUnit, knitr, rmarkdown, ggplot2, gridExtra, annotatr, LOLA,
        org.Hs.eg.db, TxDb.Hsapiens.UCSC.hg19.knownGene, parallel,
        doParallel, foreach, doRNG, matrixStats, EnvStats, ExtDist,
        gamlss, gamlss.dist
License: Artistic-2.0
URL: https://github.com/BBCG/ramr
BugReports: https://github.com/BBCG/ramr/issues
Encoding: UTF-8
biocViews: DNAMethylation, DifferentialMethylation, Epigenetics,
        MethylationArray, MethylSeq
RoxygenNote: 7.3.3
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/ramr
git_branch: RELEASE_3_23
git_last_commit: 0e5de4b
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-29 00:06:36 UTC; biocbuild
Author: Oleksii Nikolaienko [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-5910-4934>)
Maintainer: Oleksii Nikolaienko <oleksii.nikolaienko@gmail.com>

# ramr

[![](https://github.com/BBCG/ramr/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/BBCG/ramr/actions)
[![](https://codecov.io/gh/BBCG/ramr/branch/devel/graph/badge.svg)](https://app.codecov.io/gh/BBCG/ramr/tree/devel)
[![](https://bioconductor.org/shields/years-in-bioc/ramr.svg)](https://bioconductor.org/packages/release/bioc/html/ramr.html)
[![install from r-universe](https://bioc.r-universe.dev/ramr/badges/version)](https://bioc.r-universe.dev/ramr)

# Introduction

`ramr` is an R package for detection of low-frequency aberrant methylation events (epimutations) in large data sets obtained by methylation profiling using array or high-throughput methylation sequencing. In addition, package provides functions to visualize found aberrantly methylated regions (AMRs), to generate sets of all possible regions to be used as reference sets for enrichment analysis, and to generate biologically relevant test data sets for performance evaluation of AMR/DMR search algorithms.

This readme contains condensed info on `ramr` usage. For more, please check function-specific help pages and vignettes within the R environment or at [GitHub pages](https://bbcg.github.io/ramr/articles/ramr.html).

![](./vignettes/amrs.png)

### Current Features

-   Identification of aberrantly methylated regions (AMRs, i.e., epimutations)
-   AMR visualization
-   Generation of reference sets for third-party analyses (e.g., enrichment)
-   Generation of test data sets for performance evaluation of algorithms for search of differentially (DMR) or aberrantly (AMR) methylated regions

### Major improvements

##### v1.16 [BioC 3.21]

-   Major rewrite of `getAMR` and `simulateData` functions, which are now much faster (C/C++, OpenMP threads) and more robust (correctly deal with methylation sequencing data that often contains 0 and 1 values)
-   Old functions `getAMR` and `simulateData` as they were described in the `ramr` paper are now obsolete, but kept under different names (`getAMR.obsolete` and `simulateData.obsolete`, respectively) for consistency
-   Cleaner and more robust AMR plotting

------------------------------------------------------------------------

## Installation

### install via Bioconductor

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("ramr")
```

### Install the latest version via install_github

``` r
library(devtools)
install_github("BBCG/ramr", build_vignettes=FALSE,
  repos=BiocManager::repositories(),
  dependencies=TRUE, type="source")
```

------------------------------------------------------------------------

### Citing the `ramr` package

Oleksii Nikolaienko, Per Eystein Lønning, Stian Knappskog, *ramr*: an R/Bioconductor package for detection of rare aberrantly methylated regions, Bioinformatics, 2021;, btab586, <https://doi.org/10.1093/bioinformatics/btab586>

### The data underlying `ramr` manuscript

Replication Data for: "ramr: an R package for detection of rare aberrantly methylated regions, <https://doi.org/10.18710/ED8HSD>

### `ramr` at Bioconductor

[release](https://bioconductor.org/packages/release/bioc/html/ramr.html), [development version](https://bioconductor.org/packages/devel/bioc/html/ramr.html)

------------------------------------------------------------------------

# How to Use

Please read package vignettes at [GitHub pages](https://bbcg.github.io/ramr/articles/ramr.html) or within the R environment: `vignette("ramr", package="ramr")`, or consult the function's help pages for the extensive information on usage, parameters and output values.

`ramr` methods operate on objects of the class `GRanges`. The input object for AMR search must in addition contain metadata columns with sample beta values. A typical input object looks like this:

```         
GRanges object with 383788 ranges and 845 metadata columns:
             seqnames    ranges strand |         GSM1235534         GSM1235535         GSM1235536 ...
                <Rle> <IRanges>  <Rle> |          <numeric>          <numeric>          <numeric> ...
  cg13869341     chr1     15865      * |  0.801634776091808  0.846486905008704   0.86732154737116 ...
  cg24669183     chr1    534242      * |  0.834138820071765  0.861974610731835  0.832557979806823 ...
  cg15560884     chr1    710097      * |  0.711275180750356   0.70461945838556  0.699487225634589 ...
  cg01014490     chr1    714177      * | 0.0769098196182058 0.0569443780518647 0.0623154673389864 ...
  cg17505339     chr1    720865      * |  0.876413362222415  0.885593263385521  0.877944732153869 ...
         ...      ...       ...    ... .                ...                ...                ... ...
  cg05615487    chr22  51176407      * |   0.84904178467798  0.836538383875097   0.81568519870099 ...
  cg22122449    chr22  51176711      * |  0.882444486059592  0.870804215405886  0.859269224277308 ...
  cg08423507    chr22  51177982      * |  0.886406345093286  0.882430879852752  0.887241923657461 ...
  cg19565306    chr22  51222011      * | 0.0719084295670266 0.0845209871264646 0.0689074604483659 ...
  cg09226288    chr22  51225561      * |  0.724145303755024  0.696281176451351  0.711459675603635 ...
```

This code shows how to do basic analysis with `ramr` using provided data files:

``` r
library(ramr)
data(ramr)

# search for AMRs
amrs <- getAMR(data.ranges=ramr.data, compute="beta+binom", compute.estimate="amle",
               compute.weights="logInvDist", combine.min.cpgs=5, combine.threshold=1e-2, combine.window=1000)

# inspect
amrs
plotAMR(data.ranges=ramr.data, amr.ranges=amrs[1])

# generate the set of all possible genomic regions using sample data set and
# the same parameters as for AMR search
universe <- getUniverse(ramr.data, min.cpgs=5, merge.window=1000)

# enrichment analysis of AMRs using R library LOLA
library(LOLA)
hg19.coredb <- loadRegionDB(system.file("LOLACore", "hg19", package="LOLA"))
core.hits   <- runLOLA(amrs, universe, hg19.coredb, cores=1, redefineUserSets=TRUE)
```

The following code generates random AMRs and methylation beta values using provided data set as a template:

``` r
# set the seed for reproducibility
set.seed(1)

# unique random AMRs
amrs.unique <- simulateAMR(ramr.data, nsamples=10, regions.per.sample=2,
                           min.cpgs=5, merge.window=1000, dbeta=0.2)

# methylation data with AMRs
data.with.amrs <- simulateData(template.ranges=ramr.data, nsamples=99,
                               amr.ranges=amrs.unique, ncores=2)
  
# that's how regions look like
library(gridExtra)
do.call("grid.arrange", c(plotAMR(data.with.amrs, amr.ranges=amrs.unique[1:2]), ncol=2))
```

The input (or template) object may be obtained using data from various sources. Here we provide two examples:

### Using data from NCBI GEO

The following code pulls (NB: very large) raw files from NCBI GEO database, performs normalization and creates *`GRanges`* object for further analysis using `ramr` (system requirements: 22GB of disk space, 64GB of RAM)

``` r
library(minfi)
library(GEOquery)
library(GenomicRanges)
library(IlluminaHumanMethylation450kanno.ilmn12.hg19)

# destination for temporary files
dest.dir <- tempdir()

# downloading and unpacking raw IDAT files
suppl.files <- getGEOSuppFiles("GSE51032", baseDir=dest.dir, makeDirectory=FALSE, filter_regex="RAW")
# The default timeout for downloading files in R 4.1 is 60 seconds.
# If code above fails because of that, change your timeout using 
# options(timeout=600)
untar(rownames(suppl.files), exdir=dest.dir, verbose=TRUE)
idat.files  <- list.files(dest.dir, pattern="idat.gz$", full.names=TRUE)
sapply(idat.files, gunzip, overwrite=TRUE)

# reading IDAT files
geo.idat <- read.metharray.exp(dest.dir)
colnames(geo.idat) <- gsub("(GSM\\d+).*", "\\1", colnames(geo.idat))

# processing raw data
genomic.ratio.set <- preprocessQuantile(geo.idat, mergeManifest=TRUE, fixOutliers=TRUE)

# creating the GRanges object with beta values
data.ranges <- granges(genomic.ratio.set)
data.betas  <- getBeta(genomic.ratio.set)
sample.ids  <- colnames(geo.idat)
mcols(data.ranges) <- data.betas

# data.ranges and sample.ids objects are now ready for AMR search using ramr
```

### Using Bismark cytosine report files

``` r
library(methylKit)
library(GenomicRanges)

# file.list is a user-defined character vector with full file names of Bismark cytosine report files
file.list

# sample.ids is a user-defined character vector holding sample names
sample.ids

# methylation context string, defines if the reads covering both strands will be merged
context <- "CpG"

# fitting beta distribution (filtering using ramr.method "beta" or "wbeta") requires
# that most of the beta values are not equal to 0 or 1
min.beta <- 0.001
max.beta <- 0.999

# reading and uniting methylation values
meth.data.raw <- methRead(as.list(file.list), as.list(sample.ids), assembly="hg19", header=TRUE,
                          context=context, resolution="base", treatment=rep(0,length(sample.ids)),
                          pipeline="bismarkCytosineReport")
meth.data.utd <- unite(meth.data.raw, destrand=isTRUE(context=="CpG"))

# creating the GRanges object with beta values
data.ranges <- GRanges(meth.data.utd)
data.betas  <- percMethylation(meth.data.utd)/100
data.betas[data.betas<min.beta] <- min.beta
data.betas[data.betas>max.beta] <- max.beta
mcols(data.ranges) <- data.betas

# data.ranges and sample.ids objects are now ready for AMR search using ramr
```

## License

Artistic License/GPL

test_other <- function () {

  # covers helper and other internal functions

  data(ramr)

  .data <- ramr:::.preprocessData(
    data.ranges=ramr.data, data.samples=ramr.samples,
    data.coverage=as.data.frame(sapply(ramr.samples, function (s) integer(0))),
    transform="identity", exclude.range=c(2,0), ncores=1, verbose=TRUE
  )

  ramr:::rcpp_extract_out(.data)
  t(ramr:::rcpp_extract_coef(.data))
}

#' Simulated Illumina HumanMethylation 450k data set with 3000 CpGs and 100
#' samples
#'
#' Data was simulated using GSE51032 data set as described in the reference.
#' Current data set (\code{"ramr.data"}) contains beta values for 10000 CpGs
#' and 100 samples (\code{"ramr.samples"}), and carries 6 unique
#' (\code{"ramr.tp.unique"}) and 15 non-unique (\code{"ramr.tp.nonunique"})
#' true positive AMRs containing at least 10 CpGs with their beta values
#' increased/decreased by 0.5.
#'
#' @docType data
#'
#' @aliases ramr.data ramr.samples ramr.tp.unique ramr.tp.nonunique
#'
#' @usage data(ramr)
#'
#' @format Objects of class \code{"GRanges"} (\code{"ramr.data, ramr.tp.unique,
#' ramr.tp.nonunique"}) and \code{"character"} (\code{"ramr.samples"}).
#'
#' @keywords data sets
#'
#' @references Nikolaienko et al., 2020
#' (\href{https://doi.org/10.1101/2020.12.01.403501}{bioRxiv})
#'
#' @examples
#'   data(ramr)
#'   amrs <- getAMR(
#'     data.ranges=ramr.data, compute="IQR",
#'     combine.min.cpgs=5, combine.window=1000, combine.threshold=5
#'   )
#'   plotAMR(data.ranges=ramr.data, amr.ranges=amrs[1])
#'   plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.nonunique[4],
#'           highlight=c("sample7","sample8","sample9"))
#'
"ramr.data" #c("ramr.data","ramr.samples","ramr.tp.unique","ramr.tp.nonunique")

#' [OBSOLETE] Template-based simulation of methylation data sets
#'
#' @description
#' This function is fully functional but obsolete. It will remain a part of the
#' package for consistency, as it was used in `ramr` publication
#' (\doi{10.1093/bioinformatics/btab586}). Please use faster and more capable
#' \code{\link{simulateData}} instead.
#'
#' `simulateData.obsolete` generates aberration-free methylation data using an
#' experimental data set as a template, and further introduces methylation
#' aberrations if `GRanges` object containing a set of aberrantly methylated
#' regions was provided. The output can be used to evaluate performance
#' of algorithms for search of differentially (DMR) or aberrantly (AMR)
#' methylated regions.
#'
#' @details
#' For every genomic location in the template data set (`GRanges` object with
#' genomic locations and corresponding beta values included as metadata)
#' `simulateData.obsolete` estimates the parameters of beta distribution by
#' means of
#' `EnvStats::ebeta` function, and then uses estimated parameters to generate
#' `nsamples` random beta values by means of `stats::rbeta` function. This
#' results in "smoothed" data set that has biologically relevant distribution
#' of beta values at every genomic location, but does not contain methylation
#' aberrations. If the `amr.ranges` parameter points to a `GRanges` object with
#' aberrations, every AMR is then introduced into the "smoothed" data set as
#' following: if mean methylation beta value for AMR region across all samples
#' in the "smoothed" data set is above (below) 0.5 then all beta values for the
#' sample defined by the `sample` metadata column are decreased (increased) by
#' the absolute value specified in the `dbeta` metadata column. Resulting
#' data sets with (or without) AMR together with the `amr.ranges` set of true
#' positive aberrations can be used as test data set to evaluate performance
#' of algorithms for search of differentially (DMR) or aberrantly (AMR)
#' methylated regions.
#'
#' @param template.ranges A `GRanges` object with genomic locations and
#' corresponding beta values included as metadata (same object
#' must be supplied to this and to the `simulateAMR` functions).
#' @param nsamples A single integer >= 1 indicating the number of samples to
#' generate.
#' @param amr.ranges A `GRanges` object with genomic locations of (rare)
#' methylation aberrations. If `NULL` (the default), no aberrations is
#' introduced, and function will return "smoothed" data set. If supplied,
#' `GRanges` object must contain the following metadata columns:
#' \itemize{
#'   \item `revmap` -- integer list of `template.ranges` genomic locations that
#'   are included in this AMR region
#'   \item `sample` -- an identifier of a sample to which corresponding AMR
#'   belongs. Must be among the supplied or auto generated `sample.names`
#'   \item `dbeta` -- absolute deviation to be introduced. Must be numeric
#'   within the range c(0,1) or NA. When NA - the resulting beta value for
#'   the corresponding genomic position will also be NA
#' }
#' Such an object can be obtained using \code{\link{simulateAMR}} method or
#' manually.
#' @param sample.names A character vector with sample names. If `NULL` (the
#' default), sample names will be computed as
#' `paste0("sample", seq_len(nsamples))`. When specified, the length of the
#' `sample.names` vector must be equal to the value of `nsamples`.
#' @param min.beta A single numeric within the range c(0,1). All beta values
#' in the generated data set below this value will be assigned this value.
#' The default: 0.001.
#' @param max.beta A single numeric within the range c(0,1). All beta values
#' in the generated data set above this value will be assigned this value.
#' The default: 0.999.
#' @param cores A single integer >= 1. Number of processes for parallel
#' computation (the default: all but one cores). Results of parallel processing
#' are fully reproducible when the same seed is used (thanks to doRNG).
#' @param verbose boolean to report progress and timings (default: TRUE).
#' @return The output is a `GRanges` object with genomic ranges that are equal
#' to the genomic ranges of the provided template and metadata columns
#' containing generated methylation beta values for `nsamples` samples. If
#' `amr.ranges` object was supplied, then randomly generated beta values will be
#' modified accordingly.
#' @seealso \code{\link{simulateAMR}} for the generation of random methylation
#' aberrations, \code{\link{getAMR}} for identification of AMRs,
#' \code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
#' for info on enrichment analysis, and `ramr` vignettes for the description of
#' usage and sample data.
#' @examples
#'   data(ramr)
#'   amrs <-
#'     simulateAMR(ramr.data, nsamples=10, regions.per.sample=3,
#'                 samples.per.region=1, min.cpgs=5, merge.window=1000)
#'   noise <-
#'     simulateAMR(ramr.data, nsamples=10, regions.per.sample=20,
#'                 exclude.ranges=amrs, min.cpgs=1, max.cpgs=1, merge.window=1)
#'   noisy.data <-
#'     simulateData.obsolete(ramr.data, nsamples=10, amr.ranges=c(amrs,noise),
#'                           cores=2)
#'   plotAMR(noisy.data, amr.ranges=amrs[1])
#' @export
simulateData.obsolete <- function (template.ranges,
                          nsamples,
                          amr.ranges=NULL,
                          sample.names=NULL,
                          min.beta=0.001,
                          max.beta=0.999,
                          cores=max(1,parallel::detectCores()-1),
                          verbose=TRUE)
{
  if (interactive() | Sys.getenv("R_COVR")!="")
    message("This function is fully functional but *obsolete*.\n",
            "Please use faster and more capable 'simulateData' instead.\n")
  for (ns in c("EnvStats", "doParallel", "parallel", "doRNG", "foreach"))
    if (!requireNamespace(ns, quietly=TRUE) | exists(x="is.test.environment"))
      stop(ns, " is required for this function. Please install")
  `%dorng%` <- doRNG::`%dorng%`

  if (!methods::is(template.ranges,"GRanges"))
    stop("'template.ranges' must be a GRanges object")
  if (!is.null(sample.names) & length(sample.names)!=nsamples)
    stop("'sample.names' length must be equal to 'nsamples'")

  if (is.null(sample.names))
    sample.names <- sprintf(paste0("sample%0", nchar(as.character(nsamples)), "i"), seq_len(nsamples))
  if (!is.null(amr.ranges)) {
    if(!methods::is(amr.ranges,"GRanges"))
      stop("'amr.ranges' must be a GRanges object")
    if ( is.null(amr.ranges$revmap) | !all(unlist(amr.ranges$revmap) %in% seq_along(template.ranges)) )
      stop("Malformed 'amr.ranges' object: 'revmap' field is missing or contains out-of-range values")
    if ( is.null(amr.ranges$sample) | !all(amr.ranges$sample %in% sample.names) )
      stop("Malformed 'amr.ranges' object: 'sample' field is missing or its elements are absent from 'sample.names'")
    if ( !is.numeric(amr.ranges$dbeta) | !all(stats::na.omit(amr.ranges$dbeta)>=0) | !all(stats::na.omit(amr.ranges$dbeta)<=1) )
      stop("Malformed 'amr.ranges' object: 'dbeta' field is missing or is outside the range c(0,1)")
  }

  #####################################################################################

  getRandomBeta <- function(data.chunk) {
    chunk.filt <- apply(data.chunk, 1, function(x) {
      x.median    <- stats::median(x, na.rm=TRUE)
      x[is.na(x)] <- x.median
      beta.fit    <- suppressWarnings( EnvStats::ebeta(as.numeric(x)) )
      random.beta <- stats::rbeta(nsamples, beta.fit$parameters[1], beta.fit$parameters[2])
      return(random.beta)
    })
    return(t(chunk.filt))
  }

  #####################################################################################

  if (verbose) message("Simulating data", appendLF=FALSE)
  tm <- proc.time()

  template.betas <- as.matrix(GenomicRanges::mcols(template.ranges, use.names=FALSE))
  chunks <- split(seq_len(nrow(template.betas)), if (cores>1) cut(seq_len(nrow(template.betas)), cores) else 1)

  doParallel::registerDoParallel(cores)
  cl <- parallel::makeCluster(cores)
  random.betas <- foreach::foreach (chunk=chunks) %dorng% getRandomBeta(template.betas[chunk,])
  random.betas <- do.call(rbind, random.betas)
  colnames(random.betas) <- sample.names
  parallel::stopCluster(cl)

  if (verbose) message(sprintf(" [%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)

  if (!is.null(amr.ranges)) {
    if (verbose) message("Introducing epimutations", appendLF=FALSE)
    tm <- proc.time()

    amr.mcols <- data.frame(GenomicRanges::mcols(amr.ranges))
    for (i in seq_len(nrow(amr.mcols))) {
      revmap <- unlist(amr.mcols[i,"revmap"])
      dbeta  <- sign(0.5 - mean(random.betas[revmap,], na.omit=TRUE)) * amr.mcols[i,"dbeta"]
      sample <- amr.mcols[i,"sample"]
      random.betas[revmap, sample] <- random.betas[revmap, sample] + dbeta
    }

    if (verbose) message(sprintf(" [%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
  }

  random.betas[random.betas>max.beta] <- max.beta
  random.betas[random.betas<min.beta] <- min.beta

  data.ranges <- GenomicRanges::granges(template.ranges)
  GenomicRanges::mcols(data.ranges) <- random.betas

  return(data.ranges)
}

test_simulateData.obsolete <- function () {
  data(ramr)
  RUnit::checkException(
    simulateData.obsolete("ramr.data", 2)
  )
  RUnit::checkException(
    simulateData.obsolete(ramr.data, nsamples=2, sample.names=c("a"))
  )
  RUnit::checkException(
    simulateData.obsolete(ramr.data, nsamples=2, amr.ranges=c("a"))
  )
  RUnit::checkException(
    simulateData.obsolete(ramr.data[1:100], nsamples=2, amr.ranges=ramr.tp.unique)
  )
  RUnit::checkException(
    simulateData.obsolete(ramr.data, nsamples=2, amr.ranges=ramr.tp.unique)
  )
  RUnit::checkException(
    simulateData.obsolete(ramr.data, nsamples=100, amr.ranges=ramr.tp.unique)
  )
  RUnit::checkException(
    simulateData.obsolete(ramr.data, nsamples=99, amr.ranges=ramr.tp.unique)
  )

  noise <- simulateAMR(ramr.data, nsamples=10, merge.window=1, min.cpgs=1, max.cpgs=1,
                       regions.per.sample=100, samples.per.region=1, dbeta=1)
  betas <- as.matrix(GenomicRanges::mcols( simulateData.obsolete(ramr.data, nsamples=10, amr.ranges=noise, cores=2) ))
  RUnit::checkEquals(
    dim(betas),
    c(3000, 10)
  )
  RUnit::checkTrue(
    sum( betas==0.999 | betas==0.001 ) >= length(noise)
  )
  noise <- simulateAMR(ramr.data, nsamples=10, merge.window=1, min.cpgs=1, max.cpgs=1,
                       regions.per.sample=100, samples.per.region=1, dbeta=NA)
  betas <- as.matrix(GenomicRanges::mcols( simulateData.obsolete(ramr.data, nsamples=10, amr.ranges=noise, cores=2) ))
  RUnit::checkTrue(
    sum(is.na(betas)) == length(noise)
  )

  ### if suggested library is not available
  test.env <- new.env()
  assign(x="is.test.environment", value=TRUE, envir=test.env)
  test.func <- function(f, env, ...) {
    environment(f) <- env
    f(...)
  }
  RUnit::checkException(
    test.func(f=simulateData.obsolete, env=test.env, ramr.data, nsamples=10, amr.ranges=noise, cores=2)
  )
}

#' Search for aberrantly methylated regions
#'
#' @description
#' `getAMR` returns a `GRanges` object with aberrantly methylated
#' regions (AMRs / epimutations) for all samples in a data set.
#'
#' @details
#' In the provided data set, `getAMR` finds stretches of outlier beta values
#' to identify rare long-range methylation
#' aberrations (epimutations) in one or several samples. As a rule, methods for
#' differential methylation analysis rely on between-group comparisons ---
#' `getAMR` performs this comparison within-group, which is not only faster,
#' but also more sensitive. The logic of computations is described below.
#'
#' \subsection{Compute}{
#' This section describes computations that are performed in order to identify
#' individual outlier beta values --- but
#' \bold{before values are deemed as outliers}.
#' At the moment, the two supported methods are:
#'
#' \describe{
#'   \item{"IQR"}{
#'     When `compute=="IQR"`, for every genomic location (CpG) in
#'     `data.ranges` the IQR-normalized deviation from the median value is
#'     calculated using the following formula:
#'     \deqn{xIQR_i=\frac{x_i-M}{IQR}}
#'     where \eqn{x_i} is a beta value for i-th sample,
#'     \eqn{M} and \eqn{IQR} are a median and an interquartile range
#'     of all beta values at this genomic location, respectively.
#'   }
#'   \item{"beta+binom"}{
#'     When `compute=="beta+binom"`, for every genomic location (CpG),
#'     `getAMR` will estimate the probability of each beta value to occur.
#'     For all beta values inside the open \eqn{(0,1)} interval, beta
#'     distribution is used. For all \eqn{\{0;1\}} endpoint (extreme) values
#'     where beta distribution is not defined, binomial probability is
#'     calculated using coverage data (supplied using `data.coverage`
#'     parameter).
#'
#'     Alpha \eqn{{\alpha}} and beta \eqn{{\beta}} parameters of beta
#'     distribution can be estimated using one of the following methods:
#'
#'     \enumerate{
#'       \item{
#'         Method of moments (`compute.estimate="mom"`) based on
#'         (both optionally weighted) mean and unbiased variance
#'         \deqn{\text{sample mean} = \bar{x} = \frac{ \sum\limits_{i=1}^n w_i x_i}{\sum\limits_{i=1}^n w_i}}
#'         \deqn{\text{unbiased variance} =\bar{v} = \frac {\sum\limits_{i=1}^N w_i (x_i - \bar{x})^2} {\sum_{i=1}^N w_i - (\sum_{i=1}^N w_i^2 / \sum_{i=1}^N w_i)} }
#'         where \eqn{x_i} and \eqn{w_i} are a beta value and its reliability
#'         weight for i-th sample.
#'         \deqn{\hat{\alpha} = \bar{x} \left(\frac{\bar{x} (1 - \bar{x})}{\bar{v}} - 1 \right)}
#'         \deqn{\hat{\beta} = (1-\bar{x}) \left(\frac{\bar{x} (1 - \bar{x})}{\bar{v}} - 1 \right)}
#'         Note: all beta values from the closed \eqn{[0,1]} interval are used
#'         for calculation of arithmetic mean value.
#'         For more details on used formulas, visit
#'         \href{https://en.wikipedia.org/wiki/Weighted_arithmetic_mean#Mathematical_definition}{Weighted arithmetic mean},
#'         \href{https://en.wikipedia.org/wiki/Weighted_arithmetic_mean#Reliability_weights}{Weighted variance with reliability weights},
#'         and \href{https://en.wikipedia.org/wiki/Beta_distribution#Method_of_moments}{Method of moments for beta distribution}
#'       }
#'       \item{
#'         Approximate maximum likelihood (`compute.estimate="amle"`) based on
#'         (both optionally weighted) geometric means of \eqn{x} and \eqn{(1-x)}
#'         \deqn{ \hat{G}_x = \left(\prod_{i=1}^n x_i^{w_i}\right)^{1 / \sum_{i=1}^n w_i} }
#'         \deqn{ \hat{G}_{(1-x)} = \left(\prod_{i=1}^n {(1-x_i)}^{w_i}\right)^{1 / \sum_{i=1}^n w_i} }
#'         where \eqn{x_i} and \eqn{w_i} are a beta value and its reliability
#'         weight for i-th sample.
#'         \deqn{ \hat{\alpha}\approx \tfrac{1}{2} + \frac{\hat{G}_{x}}{2(1-\hat{G}_x-\hat{G}_{(1-x)})} }
#'         \deqn{ \hat{\beta}\approx \tfrac{1}{2} + \frac{\hat{G}_{(1-x)}}{2(1-\hat{G}_x-\hat{G}_{(1-x)})} }
#'         Note: only beta values from the open \eqn{(0,1)} interval are used
#'         for calculation of geometric means.
#'         For more details, visit
#'         \href{https://en.wikipedia.org/wiki/Weighted_geometric_mean}{Weighted geometric mean},
#'         and \href{https://en.wikipedia.org/wiki/Beta_distribution#Two_unknown_parameters_2}{Maximum likelihood for beta distribution}
#'       }
#'       \item{
#'         And a numerical maximum likelihood (`compute.estimate="nmle"`) which
#'         is yet to be implemented.
#'       }
#'     }
#'
#'     After estimating parameters of beta distribution,
#'     probabilities of observed beta values from the open \eqn{(0,1)} interval
#'     are computed using regularized incomplete beta function
#'     \eqn{I_x(\alpha, \beta)}. For more details, visit
#'     \href{https://en.wikipedia.org/wiki/Beta_distribution#Cumulative_distribution_function}{Cumulative distribution function for beta distribution}.
#'
#'     Probabilities of \eqn{\{0;1\}} endpoint values are computed using
#'     mean value (either arithmetic for `compute.estimate="mom"` or geometric
#'     for `compute.estimate="*mle"`) using the following formulas:
#'     \deqn{{p^0}_i=(1-\bar{x})^k}
#'     \deqn{{p^1}_i=\bar{x}^k}
#'     where \eqn{{p^0}_i} and \eqn{{p^1}_i} are probabilities of
#'     observing 0 or 1 for i-th sample, respectively,
#'     \eqn{\bar{x}} is a mean of all beta values for this genomic
#'     position, and \eqn{k} is a sequencing coverage of this genomic
#'     position for i-th sample.
#'   }
#' }
#'
#'
#' }
#'
#' \subsection{Combine}{
#' This section describes how individual beta values are deemed as outliers
#' and how these outliers are combined into extended genomic regions
#' (aberrantly methylated regions, AMRs, or epimutations).
#' The only method supported at the moment is thresholding as
#' described below.
#'
#' \describe{
#'   \item{"threshold"}{
#'     This method applies a fixed threshold (specified using
#'     `combine.threshold` parameter) to all `xIQR` or probability
#'     values computed at the previous step. All observed beta values that
#'     are passing this threshold (above or equal to the threshold for `xIQR`;
#'     below or equal in case of probability values) are considered to be
#'     outliers and therefore retained.
#'
#'     Next, for all outlier beta values per sample, corresponding genomic
#'     positions are merged into genomic intervals using the window of
#'     `combine.window` and keeping the strand information unless
#'     `combine.ignore.strand` is TRUE.
#'   }
#'   \item{"comb-p"}{
#'     This method of combining outliers into genomic ranges is yet to be
#'     implemented.
#'   }
#' }
#'
#' Resulting genomic intervals are then filtered:
#' only the regions containing at least `combine.min.cpgs`
#' outliers and which are at leas as wide as `combine.min.width` are
#' reported back.
#'
#' As a final step, the following average values are computed for every
#' aberrantly methylated region:
#' \enumerate{
#'   \item{
#'     arithmetic mean of distances of all outlier beta values to
#'     a median beta value (`dbeta`)
#'   }
#'   \item{
#'     if `compute=="IQR"`, arithmetic mean of xIQR values of all outlier
#'     genomic position (`xiqr`) OR
#'   }
#'   \item{
#'     if `compute=="beta+binom"`, geometric mean of probability values
#'     of all outlier genomic position (`pval`)
#'   }
#' }
#'
#' }
#'
#' @note
#' NA values within metadata columns of `data.ranges` are silently dropped
#' in all computations.
#'
#' @param data.ranges A `GRanges` object with genomic locations and
#' corresponding beta values included as metadata.
#' @param data.samples A character vector with sample names (e.g., a subset of
#' metadata column names). If `NULL` (the default), then all samples (metadata
#' columns) are included in the analysis.
#' @param data.coverage An optional `data.frame` object with coverage data. If
#' provided, must be an all-integer `data.frame`, with the same dimensions
#' and column names as the `data.ranges` metadata columns.
#' @param transform A character scalar specifying if beta values should be
#' used as supplied ("identity", the default) or linearly transformed ("linear")
#' to force all \eqn{\{0;1\}} endpoint (extreme) values within open \eqn{(0,1)}
#' interval using the following formula: \deqn{x'=\frac{x(N-1)+0.5}{N}}
#' where \eqn{x} is the beta value before transformation, and \eqn{N} is the
#' number of samples. Such transformation is recommended only
#' if beta values contain \eqn{\{0;1\}} values \bold{and} coverage data is NOT
#' available. See \href{https://doi.org/10.1037/1082-989x.11.1.54}{doi: 10.1037/1082-989X.11.1.54}
#' and \href{https://stats.stackexchange.com/questions/31300/dealing-with-0-1-values-in-a-beta-regression}{Dealing with 0,1 values in a beta regression} for more details.
#' @param exclude.range A numeric vector of length two. Unless `NULL`
#' (the default), all `data.ranges` genomic locations with their median
#' methylation beta value within the `exclude.range` interval are filtered out.
#' @param compute A character scalar: when "IQR" (the
#' default), AMR search based on interquantile range is performed.
#' When "beta+binom" - search is based on fitting optionally weighted
#' beta distribution (with the possibility of estimating binomial probability
#' of \eqn{\{0;1\}} endpoint values). See Details section for explanation.
#' @param compute.estimate A character scalar for the method of parameter
#' estimation of beta distribution. The default ("mom") stands for the method
#' of moments based on the unbiased estimator of variance and includes
#' \eqn{\{0;1\}} endpoints in calculation of moments (mean, unbiased variance).
#' Other options are "amle" (approximation of maximum likelihood estimation)
#' and "nmle" (numeric maximum likelihood estimation) - both ignore
#' \eqn{\{0;1\}} endpoints in calculations. See Details section for explanation.
#' @param compute.weights A character scalar for the weights assigned to
#' individual observations (beta values) and used to compute weighted
#' means and variance as described in "Compute" section below. Four available
#' weighing schemes result in different sensitivity of outlier detection and
#' rate of false positive (FP) findings: "equal" (the default) is the least
#' sensitive and gives least number of FPs, while "invDist" is the most
#' sensitive but may result in a very high number of FPs especially when
#' `combine.threshold` is too high (1e-3 or higher).
#' "logInvDist" is recommended when one desires a balance between relatively
#' low type I error rate and higher
#' detection sensitivity for both unique and non-unique AMRs.
#'
#' If "equal", all weights are equal to 1 (\eqn{w_i=1}).
#' Otherwise, weights of observations inversely depend on their distance from
#' the median (thus emphasizing outliers) and are calculated using the
#' following formulas:
#' \deqn{\text{"logInvDist": } w_i = \log{\frac{1}{|M-x_i|+\epsilon}}}
#' \deqn{\text{"sqrtInvDist": } w_i = \sqrt{\frac{1}{|M-x_i|+\epsilon}}}
#' \deqn{\text{"invDist": } w_i = \frac{1}{|M-x_i|+\epsilon}}
#' where \eqn{x_i} is a beta value for i-th sample, \eqn{M} is a median of
#' all beta values at this genomic location, and \eqn{\epsilon} is a very
#' small number (= FLT_EPSILON \eqn{\approx} 1.192093e-07).
#' @param combine A character scalar for the method used to combine individual
#' outlier genomic positions into genomic intervals (ranges). When "threshold"
#' (the default) is used, simple thresholding is applied.
#' More details are given in the "Combine" subsection below.
#' @param combine.threshold A numeric scalar setting the threshold for an
#' outlier value. When `compute=="IQR"`, methylation beta values differing
#' from the median value by at least `combine.threshold` interquartile ranges
#' are considered to be outliers (the default: 5). When `compute=="beta+binom"`,
#' all probability values not higher than `combine.threshold` are considered
#' to be outliers (the default: 0.001).
#' @param combine.window A positive integer. All significant (survived the
#' filtering stage) `data.ranges` genomic locations within this distance will be
#' merged to create AMRs (the default: 300).
#' @param combine.min.cpgs A single integer >= 1. All AMRs containing less than
#' `combine.min.cpgs` significant genomic locations are filtered out (the
#' default: 7).
#' @param combine.min.width A single integer >= 1 (the default).
#' Only AMRs with the width of at least `combine.min.width` are returned.
#' @param combine.ignore.strand A boolean scalar to ignore strand information
#' in the input `data.ranges` and when outlier genomic positions are combined
#' into genomic intervals (the default: FALSE).
#' @param ncores A single integer >= 1. Number of OpenMP threads for parallel
#' computation (the default: half of the available cores). Results of parallel
#' processing are fully reproducible.
#' @param verbose Boolean to report progress and timings (default: TRUE).
#' @return The output is a `GRanges` object that contains all the aberrantly
#' methylated regions (AMRs / epimutations) for all `data.samples` samples in
#' `data.ranges` object. The following metadata columns may be present:
#' \itemize{
#'   \item `revmap` -- integer list of significant CpGs (`data.ranges` genomic
#'   locations) that are included in this AMR region
#'   \item `ncpg` -- number of significant CpGs within this AMR region
#'   \item `sample` -- contains an identifier of a sample to which
#'   corresponding AMR belongs
#'   \item `dbeta` -- average deviation of beta values for significant CpGs from
#'   their corresponding median values
#'   \item `pval` -- geometric mean of p-values for significant CpGs
#'   \item `xiqr` -- average IQR-normalised deviation of beta values for
#'   significant CpGs from their corresponding median values
#' }
#' @seealso \code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
#' for info on enrichment analysis, \code{\link{simulateAMR}} and
#' \code{\link{simulateData}} for the generation of simulated test data sets,
#' and `ramr` vignettes for the description of usage and sample data.
#' @examples
#'   data(ramr)
#'   getAMR(data.ranges=ramr.data, data.samples=ramr.samples,
#'          compute="beta+binom", compute.estimate="amle",
#'          combine.min.cpgs=5, combine.window=1000, combine.threshold=1e-3)
#' @export
getAMR <- function (data.ranges,
                    data.samples=NULL,
                    data.coverage=NULL,
                    transform=c("identity", "linear"),
                    exclude.range=NULL,
                    compute=c("IQR", "beta+binom"),
                    compute.estimate=c("mom", "amle", "nmle"),
                    compute.weights=c("equal", "logInvDist", "sqrtInvDist", "invDist"),
                    combine=c("threshold", "comb-p"),
                    combine.threshold=ifelse(compute=="IQR", 5, 1e-3),
                    combine.window=300,
                    combine.min.cpgs=7,
                    combine.min.width=1,
                    combine.ignore.strand=FALSE,
                    ncores=NULL,
                    verbose=TRUE)
{
  if (!methods::is(data.ranges,"GRanges"))
    stop("'data.ranges' must be a GRanges object")
  data.mcols <- GenomicRanges::mcols(data.ranges)

  if (is.null(data.samples)) {
    data.samples <- colnames(data.mcols)
  } else {
    if (!all(data.samples %in% colnames(data.mcols)))
      stop("'data.ranges' metadata must include 'data.samples'")
  }
  if (length(data.samples)<3)
    stop("at least three 'data.samples' must be provided")

  if (is.null(data.coverage)) {
    data.coverage <- as.data.frame(
      sapply(data.samples, function (s) integer(0))
    )
    is.coverage <- FALSE
  } else {
    if (!methods::is(data.coverage, "data.frame") |
        !identical(dim(data.mcols), dim(data.coverage)) |
        !identical(colnames(data.mcols), colnames(data.coverage)) |
        !all(apply(data.coverage, 2, is.integer)))
      stop("When provided, 'data.coverage' must be",
           " an all-integer 'data.frame' object",
           " of the same dimensions as, and with the colnames identical to",
           " 'data.ranges' metadata")
    is.coverage <- TRUE
  }

  if (is.null(exclude.range))
    exclude.range <- c(2,0) # // exclude those that are >= than 2 and <= than 0

  transform <- match.arg(transform)
  compute <- match.arg(compute)
  compute.estimate <- match.arg(compute.estimate)
  compute.weights <- match.arg(compute.weights)
  combine <- match.arg(combine)

  if (compute.estimate=="nmle")
    stop("compute.estimate=='nmle' is not available yet")
  if (combine=="comb-p")
    stop("combine=='comb-p' is not available yet")

  #####################################################################################

  .data <- .preprocessData(
    data.ranges=data.ranges, data.samples=data.samples,
    data.coverage=data.coverage, transform=transform,
    exclude.range=exclude.range, ncores=ncores, verbose=verbose
  )

  if (compute=="IQR") {
    .getAMR.IQR(
      data.list=.data, threshold=combine.threshold, verbose=verbose
    )
  } else if (compute=="beta+binom") {
    .getAMR.beta(
      data.list=.data,
      estimate=compute.estimate,
      weights=compute.weights,
      coverage=is.coverage,
      threshold=log(combine.threshold),
      verbose=verbose
    )
  }

  amr.ranges <- .createGranges(
    data.list=.data,
    compute=compute,
    window=combine.window,
    min.cpgs=combine.min.cpgs,
    min.width=combine.min.width,
    ignore.strand=combine.ignore.strand,
    verbose=verbose
  )

  return(amr.ranges)
}

test_getAMR <- function () {
  data(ramr)

  RUnit::checkException(
    getAMR(data.ranges=c())
  )
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, data.samples=ramr.samples[1:2])
  )
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, data.samples=c("a","b","c"))
  )
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, data.samples=ramr.samples, compute="zzz")
  )
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, compute.estimate="nmle")
  )
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, combine="comb-p")
  )
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, data.coverage=1)
  )
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, data.coverage=data.frame())
  )

  test.coverage <- as.data.frame(matrix(data=rbinom(n=3000*100, 100, 1:100/100), ncol=100))
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, data.coverage=test.coverage)
  )
  colnames(test.coverage) <- ramr.samples
  RUnit::checkException(
    getAMR(data.ranges=ramr.data, data.coverage=test.coverage[-1,])
  )

  amr.iqr.1 <- getAMR(data.ranges=ramr.data, compute="IQR", combine.min.cpgs=5, combine.window=10000, combine.threshold=5, ncores=1)
  amr.iqr.2 <- getAMR(data.ranges=ramr.data, data.coverage=test.coverage, compute="IQR", combine.min.cpgs=5, combine.window=10000, combine.threshold=5, ncores=2)
  RUnit::checkIdentical(
    amr.iqr.1,
    amr.iqr.2
  )
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.iqr.2, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.iqr.2, ramr.tp.nonunique))),
    c(6, 45)
  )

  amr.beta <- getAMR(data.ranges=ramr.data, data.samples=ramr.samples, data.coverage=test.coverage, compute="beta+binom", combine.min.cpgs=5, combine.window=10000, combine.threshold=1e-3)
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.beta, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.beta, ramr.tp.nonunique))),
    c(6, 45)
  )

  amr.wbeta <- getAMR(data.ranges=ramr.data, data.samples=ramr.samples, compute="beta+binom", compute.estimate="amle", compute.weights="sqrtInvDist",
                      combine.min.cpgs=5, combine.window=10000, combine.threshold=1e-5, ncores=-1)
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.wbeta, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.wbeta, ramr.tp.nonunique))),
    c(6, 45)
  )

  amr.iqr.3 <- getAMR(data.ranges=ramr.data, compute="IQR", combine.min.cpgs=5, combine.window=10000, combine.threshold=5, exclude.range=c(0.1,0.9))
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.iqr.3, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.iqr.3, ramr.tp.nonunique))),
    c(2, 18)
  )

  # subsetting
  amr.all <- getAMR(data.ranges=ramr.data, data.coverage=test.coverage, combine.window=1000, combine.min.cpgs=5, combine.threshold=3)
  amr.half <- getAMR(data.ranges=ramr.data, data.coverage=test.coverage, combine.window=1000, combine.min.cpgs=5, combine.threshold=3, data.samples=ramr.samples[1:50])
  RUnit::checkTrue(
    !identical(amr.all, amr.half)
  )
  RUnit::checkTrue(
    all(amr.half$sample %in% ramr.samples[1:50])
  )

  ### tests to cover 0/1/NA values during fitting

  data.mcols <- GenomicRanges::mcols(ramr.data)[, -1]
  set.seed(1)
  data.mcols[sample(x=seq_len(nrow(data.mcols)), size=10), sample(x=seq_len(ncol(data.mcols)), size=10)] <- NA
  data.mcols[sample(x=seq_len(nrow(data.mcols)), size=10), sample(x=seq_len(ncol(data.mcols)), size=10)] <- 0
  data.mcols[sample(x=seq_len(nrow(data.mcols)), size=10), sample(x=seq_len(ncol(data.mcols)), size=10)] <- 1
  data.mcols[1500, ] <- NA
  mod.data <- GenomicRanges::granges(ramr.data)
  GenomicRanges::strand(mod.data) <- c("+", "-")
  GenomicRanges::mcols(mod.data) <- data.mcols
  mod.coverage <- as.data.frame(matrix(data=rbinom(n=nrow(data.mcols)*ncol(data.mcols), ncol(data.mcols), 1:100/100), ncol=ncol(data.mcols)))
  colnames(mod.coverage) <- colnames(data.mcols)

  getAMR(data.ranges=mod.data, data.coverage=mod.coverage, compute="beta+binom", combine.min.cpgs=5, combine.window=10000, combine.threshold=1e-3, combine.ignore.strand=TRUE)
  getAMR(data.ranges=mod.data, compute="IQR", combine.min.cpgs=5, combine.window=10000, combine.threshold=3, combine.ignore.strand=TRUE)
  for (e in c("mom", "amle"))
    for (w in c("equal", "logInvDist", "sqrtInvDist", "invDist"))
      getAMR(data.ranges=mod.data, compute="beta+binom", compute.estimate=e, compute.weights=w, combine.min.cpgs=5, combine.window=10000, combine.threshold=1e-3)
  getAMR(data.ranges=mod.data, transform="linear", compute="beta+binom", compute.estimate=e, compute.weights=w, combine.min.cpgs=5, combine.window=10000, combine.threshold=1e-3)
}

#' Simulate a set of aberrantly methylated regions
#'
#' @description
#' `simulateAMR` returns a `GRanges` object containing a set of randomly
#' selected aberrantly methylated regions (AMRs) to be used as an input for the
#' `simulateData` method.
#'
#' @details
#' Using provided template (`GRanges` object) `simulateAMR` randomly selects
#' genomic regions satisfying various criteria (number of CpGs, width of the
#' region) and assigns them to samples according to specified parameters
#' (number of AMRs per sample, number of samples per AMR). Its output is meant
#' to be used as the set of true positive AMRs for the `simulateData` function.
#'
#' @param template.ranges A `GRanges` object with genomic locations (same object
#' must be supplied to this and to the `simulateData` functions).
#' @param nsamples A single integer >= 1 indicating the number of samples to
#' which AMRs will be assigned.
#' @param exclude.ranges A `GRanges` object with genomic locations. None of the
#' simulated AMRs in the output will overlap with any of regions from
#' `exclude.ranges`. If `NULL` (the default), AMRs are not restricted by their
#' genomic location.
#' @param regions.per.sample A single integer >= 1 (the default). Number of AMRs
#' to be assigned to every sample. Message is shown and the `regions.per.sample`
#' value is limited to `maxnAMR %/% nsamples` if it is greater than this number
#' (where `maxnAMR` is the maximum number of potential AMRs for the
#' `template.ranges`).
#' @param samples.per.region A single integer >= 1 (the default). Number of
#' samples to which the same AMR will be assigned. Message is shown and the
#' `samples.per.region` value is limited to `nsamples` if the former is greater
#' than the latter.
#' @param sample.names A character vector with sample names. If `NULL` (the
#' default), sample names will be computed as
#' `paste0("sample", seq_len(nsamples))`. When specified, the length of the
#' `sample.names` vector must not be smaller than the value of `nsamples`.
#' @param merge.window A positive integer. All `template.ranges` genomic
#' locations within this distance will be merged to create a list of potential
#' AMRs (which will be later filtered from regions overlapping with any regions
#' from the `exclude.ranges`).
#' @param min.cpgs A single integer >= 1. All AMRs containing less than
#' `min.cpgs` genomic locations are filtered out. The default: 7.
#' @param max.cpgs A single integer >= 1. All AMRs containing more than
#' `max.cpgs` genomic locations are filtered out. The default: `Inf`.
#' @param min.width A single integer >= 1 (the default). Only AMRs with the
#' width of at least `min.width` are returned.
#' @param dbeta A single non-negative numeric value in the range [0,1] or a
#' numeric vector of such values (with as many elements as there are AMRs).
#' Used to populate the `dbeta` metadata column, defines a desired absolute
#' deviation of corresponding AMR from the median for the `simulateData`
#' function.
#' @return The output is a `GRanges` object that contains a subset of
#' aberrantly methylated regions (AMRs) randomly selected from all the possible
#' AMRs for the provided `template.ranges` object. The following metadata
#' columns are included:
#' \itemize{
#'   \item `revmap` -- integer list of `template.ranges` genomic locations that
#'   are included in this AMR region
#'   \item `ncpg` -- number of `template.ranges` genomic locations within
#'   this AMR region
#'   \item `sample` -- an identifier of a sample to which
#'   corresponding AMR belongs
#'   \item `dbeta` -- equals to supplied `dbeta` parameter
#' }
#' @seealso \code{\link{simulateData}} for the generation of simulated test
#' data sets, \code{\link{getAMR}} for identification of AMRs,
#' \code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
#' for info on enrichment analysis, and `ramr` vignettes for the description of
#' usage and sample data.
#' @examples
#'   data(ramr)
#'   set.seed(1)
#'   amrs.unique <-
#'     simulateAMR(ramr.data, nsamples=4, regions.per.sample=2,
#'                 min.cpgs=5, merge.window=1000, dbeta=0.2)
#'   amrs.nonunique <-
#'     simulateAMR(ramr.data, nsamples=3, exclude.ranges=amrs.unique,
#'                 samples.per.region=2, min.cpgs=5, merge.window=1000)
#' @export
simulateAMR <- function (template.ranges,
                         nsamples,
                         exclude.ranges=NULL,
                         regions.per.sample=1,
                         samples.per.region=1,
                         sample.names=NULL,
                         merge.window=300,
                         min.cpgs=7,
                         max.cpgs=Inf,
                         min.width=1,
                         dbeta=0.25)
{
  if (!methods::is(template.ranges,"GRanges"))
    stop("'template.ranges' must be a GRanges object")
  if (!is.null(sample.names) & length(sample.names)<nsamples)
    stop("'sample.names' length must be greater or equal to 'nsamples'")

  #####################################################################################

  repRotate <- function(v, times=1, shift=1) {
    r <- v
    for (i in seq_len(times-1)) {
      v <- c(utils::tail(v, -shift), utils::head(v, shift))
      r <- c(r, v)
    }
    return(r)
  }

  #####################################################################################

  universe.ranges <- getUniverse(template.ranges, merge.window=merge.window, min.cpgs=min.cpgs, min.width=min.width)
  universe.ranges <- subset(universe.ranges, `ncpg`<=max.cpgs)
  if (methods::is(exclude.ranges,"GRanges"))
    universe.ranges <- IRanges::subsetByOverlaps(universe.ranges, exclude.ranges, invert=TRUE)
  if (is.null(sample.names))
    sample.names <- sprintf(paste0("sample%0", nchar(as.character(nsamples)), "i"), seq_len(nsamples))

  if (nsamples > length(universe.ranges)) {
    nsamples <- length(universe.ranges)
    message("'nsamples' has been set to the maximum possible value of ", nsamples)
  }
  if (regions.per.sample > length(universe.ranges) %/% nsamples) {
    regions.per.sample <- length(universe.ranges) %/% nsamples
    message("'regions.per.sample' has been set to the maximum possible value of ", regions.per.sample)
  }
  if (samples.per.region > nsamples) {
    samples.per.region <- nsamples
    message("'samples.per.region' has been set to the maximum possible value of ", nsamples)
  }

  amr.ranges        <- rep(sample(universe.ranges, nsamples * regions.per.sample), samples.per.region)
  amr.ranges$sample <- repRotate(rep(sample(sample.names, nsamples), regions.per.sample), times=samples.per.region, shift=1)
  amr.ranges$dbeta  <- as.numeric(dbeta)

  return(amr.ranges)
}

test_simulateAMR <- function () {
  data(ramr)
  RUnit::checkException(
    simulateAMR("ramr.data", 2)
  )
  RUnit::checkException(
    simulateAMR(ramr.data, nsamples=2, sample.names=c("a"))
  )
  RUnit::checkEquals(
    length( simulateAMR(ramr.data, nsamples=6, exclude.ranges=ramr.tp.unique) ),
    6
  )
  RUnit::checkEquals(
    length( simulateAMR(ramr.data, nsamples=1000, regions.per.sample=1000, samples.per.region=1000, merge.window=1000) ),
    143**2
  )

  unique    <- simulateAMR(ramr.data, nsamples=29, regions.per.sample=2, samples.per.region=1)
  nonunique <- simulateAMR(ramr.data, nsamples=20, exclude.ranges=unique, merge.window=1000, regions.per.sample=5, samples.per.region=3)
  noise     <- simulateAMR(ramr.data, nsamples=100, exclude.ranges=c(unique,nonunique), merge.window=1, min.cpgs=1, max.cpgs=1, regions.per.sample=1000, samples.per.region=1)
  RUnit::checkEquals(
    sum(GenomicRanges::countOverlaps(unique, nonunique)),
    0
  )
  RUnit::checkEquals(
    sum(GenomicRanges::countOverlaps(noise, c(unique,nonunique))),
    0
  )
}

test_simulateData <- function () {
  data(ramr)
  RUnit::checkException(
    simulateData("ramr.data", 2)
  )
  RUnit::checkException(
    simulateData(template.ranges=ramr.data, nsamples=2, sample.names=c("a"))
  )
  RUnit::checkException(
    simulateData(template.ranges=ramr.data, nsamples=2, amr.ranges=c("a"))
  )
  RUnit::checkException(
    simulateData(template.ranges=ramr.data[1:100], nsamples=2, amr.ranges=ramr.tp.unique)
  )
  RUnit::checkException(
    simulateData(template.ranges=ramr.data, nsamples=2, amr.ranges=ramr.tp.unique)
  )
  RUnit::checkException(
    simulateData(template.ranges=ramr.data, nsamples=100, amr.ranges=ramr.tp.unique)
  )
  RUnit::checkException(
    simulateData(template.ranges=ramr.data, nsamples=99, amr.ranges=ramr.tp.unique)
  )

  noise <- simulateAMR(template.ranges=ramr.data, nsamples=10, merge.window=1, min.cpgs=1, max.cpgs=1,
                       regions.per.sample=100, samples.per.region=1, dbeta=1)
  betas <- as.matrix(GenomicRanges::mcols( simulateData(template.ranges=ramr.data, nsamples=10, amr.ranges=noise, ncores=0) ))
  RUnit::checkEquals(
    dim(betas),
    c(3000, 10)
  )
  RUnit::checkTrue(
    sum( betas==1 | betas==0 ) >= length(noise)
  )
  noise <- simulateAMR(template.ranges=ramr.data, nsamples=10, merge.window=1, min.cpgs=1, max.cpgs=1,
                       regions.per.sample=100, samples.per.region=1, dbeta=NA)
  betas <- as.matrix(GenomicRanges::mcols( simulateData(ramr.data, nsamples=10, amr.ranges=noise) ))
  RUnit::checkTrue(
    sum(is.na(betas)) == length(noise)
  )

  ### tests to cover 0/1/NA values during simulation

  data.mcols <- GenomicRanges::mcols(ramr.data)
  set.seed(1)
  data.mcols[sample(x=seq_len(nrow(data.mcols)), size=10), sample(x=seq_len(ncol(data.mcols)), size=10)] <- NA
  data.mcols[sample(x=seq_len(nrow(data.mcols)), size=10), sample(x=seq_len(ncol(data.mcols)), size=10)] <- 0
  data.mcols[sample(x=seq_len(nrow(data.mcols)), size=10), sample(x=seq_len(ncol(data.mcols)), size=10)] <- 1
  data.mcols[1500, ] <- NA
  mod.data <- ramr.data
  GenomicRanges::mcols(mod.data) <- data.mcols

  simulateData(mod.data, nsamples=100, compute="beta+binom", compute.estimate="amle", compute.weights="logInvDist")
  RUnit::checkException(
    simulateData(mod.data, nsamples=100, compute="beta+binom", compute.estimate="nmle", compute.weights="logInvDist")
  )

  # parallel reproducibility
  set.seed(1)
  rnd1 <- simulateData(mod.data, nsamples=100, compute="beta+binom", compute.estimate="amle", compute.weights="logInvDist", ncores=1)
  set.seed(1)
  rnd2 <- simulateData(mod.data, nsamples=100, compute="beta+binom", compute.estimate="amle", compute.weights="logInvDist", ncores=2)
  RUnit::checkTrue(
    identical(rnd1, rnd2)
  )
  rnd3 <- simulateData(mod.data, nsamples=100, compute="beta+binom", compute.estimate="amle", compute.weights="logInvDist", ncores=1)
  RUnit::checkTrue(
    !identical(rnd1, rnd3)
  )
}

#' Merges, filters and outputs all genomic regions of a given `GRanges` object
#'
#' @description
#' `getUniverse` returns a `GRanges` object with all the genomic regions in a
#' data set, that can be used for AMR enrichment analysis
#'
#' @details
#' In the provided data set `getUniverse` merges and outputs all the genomic
#' regions that satisfy filtering criteria, thus creating a `GRanges` object to
#' be used as a reference set of genomic regions for AMR enrichment analysis.
#'
#' @param data.ranges A `GRanges` object with genomic locations and
#' corresponding beta values included as metadata.
#' @param merge.window A single integer >= 1. All `data.ranges` genomic
#' locations within this distance will be merged (the default: 300).
#' @param min.cpgs A single integer >= 1. All genomic regions containing less
#' than `min.cpgs` genomic locations are filtered out (the default: 7).
#' @param min.width A single integer >= 1 (the default). Only regions with the
#' width of at least `min.width` are returned.
#' @return The output is a `GRanges` object that contain all the genomic regions
#' in `data.ranges` object (in other words, all potential AMRs).
#' @seealso \code{\link{getAMR}} for identification of AMRs,
#' \code{\link{plotAMR}} for plotting AMRs, \code{\link{simulateAMR}} and
#' \code{\link{simulateData}} for the generation of simulated test data sets,
#' and `ramr` vignettes for the description of usage and sample data.
#' @examples
#'   data(ramr)
#'   universe <- getUniverse(ramr.data, min.cpgs=5, merge.window=1000)
#' \donttest{
#'   # identify AMRs
#'   amrs <- getAMR(
#'     data.ranges=ramr.data, compute="beta+binom",
#'     combine.min.cpgs=5, combine.window=1000, combine.threshold=1e-3
#'   )
#'
#'   # AMR enrichment analysis using LOLA
#'   library(LOLA)
#'   # download LOLA region databases from http://databio.org/regiondb
#'   hg19.extdb.file <- system.file("LOLAExt", "hg19", package="LOLA")
#'   if (file.exists(hg19.extdb.file)) {
#'     hg19.extdb  <- loadRegionDB(hg19.extdb.file)
#'     runLOLA(amrs, universe, hg19.extdb, cores=1, redefineUserSets=TRUE)
#'   }
#' }
#' @export
getUniverse <- function (data.ranges,
                         merge.window=300,
                         min.cpgs=7,
                         min.width=1)
{
  if (!methods::is(data.ranges,"GRanges"))
    stop("'data.ranges' must be a GRanges object")

  universe.ranges <- GenomicRanges::reduce(data.ranges, min.gapwidth=merge.window, with.revmap=TRUE)
  if (length(universe.ranges)>0) {
    universe.ranges$ncpg <- unlist(lapply(universe.ranges$revmap, length))
    universe.ranges      <- subset(universe.ranges, `ncpg`>=min.cpgs & `width`>=max(1,min.width))
  }
  return(universe.ranges)
}

test_getUniverse <- function () {
  data(ramr)
  RUnit::checkException(
    getUniverse(c())
  )
  RUnit::checkEquals(
    length( getUniverse(ramr.data, min.cpgs=1, merge.window=1) ),
    length(ramr.data)
  )
  RUnit::checkTrue(
    all( GenomicRanges::width( getUniverse(ramr.data, min.cpgs=10, merge.window=1000) ) > 1000 )
  )
}

#' @importFrom BiocGenerics relist start strand
#' @importFrom data.table as.data.table foverlaps melt.data.table setkeyv
#' @importFrom Seqinfo seqnames
#' @importFrom GenomicRanges findOverlaps GRanges granges mcols `mcols<-` reduce
#' @importFrom IRanges IRanges subsetByOverlaps
#' @importFrom methods as is
#' @importFrom Rcpp sourceCpp
#' @importFrom S4Vectors as.factor DataFrame I queryHits runLength runValue
#' @importFrom stats median na.omit setNames
#' @importFrom utils globalVariables head packageVersion tail
#' @useDynLib ramr, .registration=TRUE

# egrep -RIho -E "[a-zA-Z0-9._]+::[a-zA-Z0-9._]+" R/* | sort -f | uniq -c

################################################################################
# Globals, unload, attach
################################################################################

utils::globalVariables(c(
  "..data.samples", ":=", "alpha", "chunk", "color", "column", "end", "ncpg",
  "size", "start", "width"
))

.onUnload <- function (libpath) {library.dynam.unload("ramr", libpath)}

.onAttach <- function(libname, pkgname) {
  if(interactive() | Sys.getenv("R_COVR")!="") {
    max.threads <- rcpp_test_omp()
    msg <- ifelse(
      max.threads<0,
      paste0(
        "Multithreading (OpenMP) is not available.\n",
        "Check how to enable it at https://github.com/BBCG/ramr"
      ),
      sprintf(
        "ramr v%s using %i out of %i available threads",
        utils::packageVersion("ramr"), max(1, max.threads %/% 2), max.threads
      )
    )
    packageStartupMessage(msg)
  }
  invisible()
}

################################################################################
# Constants
################################################################################

# descr: ...

#

################################################################################
# Functions
################################################################################

# descr: partitions SeqRunLengths for parallel processing
# value: integer vector

.getPartitions <- function (seqrunlens,
                            ncores)
{
  # need a warning if too many runlengths...
  # kept it as a separate function to be able to switch to some other type of
  # partitioning later (e.g., having same seqnames on the same thread)

  total <- sum(seqrunlens)
  chunks <- rep(total %/% ncores, ncores)
  chunks[ncores] <- chunks[ncores] + total %% ncores

  return(cumsum(c(0, chunks)))
}

################################################################################

# descr: preprocesses data
# value: list

.preprocessData <- function (data.ranges,
                             data.samples,
                             data.coverage,
                             transform,
                             exclude.range,
                             ncores,
                             verbose)
{
  if (verbose) message("Preprocessing data ", appendLF=FALSE)
  tm <- proc.time()

  available.cores <- rcpp_test_omp()
  if (is.null(ncores)) {
    ncores <- max(1, available.cores %/% 2)
  } else {
    ncores <- max(1, min(ncores, available.cores))
  }

  chunks <- .getPartitions(
    seqrunlens=S4Vectors::runLength(Seqinfo::seqnames(data.ranges)),
    ncores=ncores
  )

  fn <- paste("rcpp_prepare_data", transform, sep="_")
  data.object <- do.call(what=fn, args=list(
    seqnames=S4Vectors::runValue(Seqinfo::seqnames(data.ranges)),
    seqrunlens=S4Vectors::runLength(Seqinfo::seqnames(data.ranges)),
    start=BiocGenerics::start(data.ranges),
    strand=S4Vectors::as.factor(BiocGenerics::strand(data.ranges)),
    mcols=as.data.frame(GenomicRanges::mcols(data.ranges), optional=TRUE)[, data.samples],
    coverage=as.data.frame(data.coverage, optional=TRUE)[, data.samples],
    exclude_lower=exclude.range[1],
    exclude_upper=exclude.range[2],
    chunks=chunks
  ))

  if (verbose) message(sprintf("[%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
  return(data.object)
}

################################################################################

# descr: computes and filters by IQR
# value: void

.getAMR.IQR <- function (data.list,
                         threshold,
                         verbose)
{
  if (verbose) message("Computing IQR ", appendLF=FALSE)
  tm <- proc.time()

  rcpp_get_iqr(data=data.list)
  rcpp_compute_xiqr(data=data.list)
  rcpp_filter_threshold_xiqr(data=data.list, thrshld=threshold)

  if (verbose) message(sprintf("[%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
}

################################################################################

# descr: fits beta distribution and filters by p-value
# value: void

.getAMR.beta <- function (data.list,
                          estimate,
                          weights,
                          coverage,
                          threshold,
                          verbose)
{
  if (verbose) message("Fitting beta distribution ", appendLF=FALSE)
  tm <- proc.time()

  fn.mean <- paste(
    "rcpp_get_meanvar",
    if (estimate=="mom") "ari" else "geo",
    weights,
    sep="_"
  )
  do.call(what=fn.mean, args=list(data=data.list))

  fn.fit <- paste("rcpp_fit_beta", estimate, sep="_")
  do.call(what=fn.fit, args=list(data=data.list))

  if (coverage==TRUE)
    rcpp_fit_binom(data=data.list)

  fn.logp <- paste0("rcpp_compute_logp_beta", if (coverage) "_binom")
  do.call(what=fn.logp, args=list(data=data.list))

  rcpp_filter_threshold_logp(data=data.list, thrshld=threshold)

  if (verbose) message(sprintf("[%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
}

################################################################################

# descr: creates GenomicRanges
# value: GRanges object

.createGranges <- function (data.list,
                            compute,
                            window,
                            min.cpgs,
                            min.width,
                            ignore.strand,
                            verbose)
{
  if (verbose) message("Creating genomic ranges ", appendLF=FALSE)
  tm <- proc.time()

  fn.ranges <- paste(
    "rcpp_create_granges",
    if (ignore.strand) "unstranded" else "stranded",
    if (compute=="IQR") "xiqr" else "logp",
    sep="_"
  )
  amr.list <- do.call(what=fn.ranges, args=list(
    data=data.list, window=window, min_ncpg=min.cpgs, min_width=min.width
  ))

  amr.ranges <- GenomicRanges::GRanges(
    seqnames=amr.list$seqnames,
    ranges=IRanges::IRanges(start=amr.list$start, end=amr.list$end),
    strand=amr.list$strand,
    revmap=S4Vectors::I(amr.list$revmap),
    S4Vectors::DataFrame(
      amr.list[c("ncpg", "sample", "dbeta",
                 if (compute=="IQR") "xiqr" else "pval")]
    )
  )

  if (verbose) message(sprintf("[%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
  return(amr.ranges)
}

################################################################################

# descr: produces random data
# value: matrix

.getRandomValues <- function (data.list,
                              estimate,
                              weights,
                              nsamples,
                              sample.names,
                              verbose)
{
  if (verbose) message("Simulating data ", appendLF=FALSE)
  tm <- proc.time()

  fn.mean <- paste(
    "rcpp_get_meanvar",
    if (estimate=="mom") "ari" else "geo",
    weights,
    sep="_"
  )
  do.call(what=fn.mean, args=list(data=data.list))

  fn.fit <- paste("rcpp_fit_beta", estimate, sep="_")
  do.call(what=fn.fit, args=list(data=data.list))

  random.values <- rcpp_generate_random_values(data=data.list, ncol=nsamples)

  colnames(random.values) <- sample.names

  if (verbose) message(sprintf("[%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
  return(random.values)
}

################################################################################

# descr: introduces epimutations in random data
# value: matrix

.addEpimutations <- function (random.data,
                              amr.ranges,
                              verbose)
{
  if (verbose) message("Introducing epimutations", appendLF=FALSE)
  tm <- proc.time()

  amr.mcols <- data.frame(GenomicRanges::mcols(amr.ranges))
  for (i in seq_len(nrow(amr.mcols))) {
    revmap <- unlist(amr.mcols[i,"revmap"])
    dbeta  <- sign(0.5 - mean(random.data[revmap,], na.omit=TRUE)) * amr.mcols[i,"dbeta"]
    sample <- amr.mcols[i,"sample"]
    random.data[revmap, sample] <- random.data[revmap, sample] + dbeta
  }
  random.data[random.data<0] <- 0
  random.data[random.data>1] <- 1

  if (verbose) message(sprintf("[%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
  return(random.data)
}

################################################################################

#' Plot aberrantly methylated regions
#'
#' @description
#' `plotAMR` uses `ggplot2` to visualize aberrantly methylated regions (AMRs)
#' at particular genomic locations.
#'
#' @details
#' For every non-overlapping genomic location from `amr.ranges` object,
#' `plotAMR` plots and outputs a line graph of methylation beta values taken
#' from `data.ranges` for all samples from `data.samples`. Samples bearing
#' significantly different methylation profiles ('sample' column of
#' `amr.ranges` object) are highlighted.
#'
#' @param data.ranges A `GRanges` object with genomic locations and
#' corresponding beta values included as metadata.
#' @param amr.ranges An output of `getAMR` - a `GRanges` object that contain
#' aberrantly methylated regions (AMRs).
#' @param data.samples A character vector with sample names (a subset of
#' metadata column names) to be included in the plot. If `NULL` (the default),
#' then all samples (metadata columns) are included.
#' @param window An optional integer constant to expand genomic ranges of the
#' `amr.ranges` object (the default: 300).
#' @param ignore.strand Boolean to ignore strand of AMR region. Default: FALSE.
#' @param highlight An optional list of samples to highlight. If NULL (the
#' default), will contain sample IDs from the `sample` metadata column of
#' `amr.ranges` object.
#' @param title An optional title for the plot. If NULL (the default), plot
#' title is set to a genomic location of particular AMR.
#' @param labs Optional axis labels for the plot. Default: c("genomic position",
#' "beta value").
#' @param transform Optional transformation of y-axis. Default: "identity"
#' (no transformation).
#' @param limits Optional limits of y-axis. When default (NULL), limits
#' are c(NA,1) for `transform=="log10"` and c(0,1) otherwise.
#' @param breaks Optional breaks of y-axis. When default (NULL), breaks
#' are `10**(seq(from=-5, to=0, length.out=6))` for `transform=="log10"` and
#' `seq(from=0, to=1, length.out=6)` otherwise.
#' @param verbose Boolean to report progress and timings (default: TRUE).
#' @return The output is a list of `ggplot` objects.
#' @seealso \code{\link{getAMR}} for identification of AMRs,
#' \code{\link{getUniverse}} for info on enrichment analysis,
#' \code{\link{simulateAMR}} and \code{\link{simulateData}} for the generation
#' of simulated test data sets, and `ramr` vignettes for the description of
#' usage and sample data.
#' @examples
#'   data(ramr)
#'   plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.unique[1])
#'   library(gridExtra)
#'   do.call("grid.arrange",
#'           c(plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.nonunique), ncol=2))
#' @export
plotAMR <- function (data.ranges,
                     amr.ranges,
                     data.samples=NULL,
                     window=300,
                     ignore.strand=FALSE,
                     highlight=NULL,
                     title=NULL,
                     labs=c("genomic position", "beta value"),
                     transform=c("identity", "log1p", "log10"),
                     limits=NULL,
                     breaks=NULL,
                     verbose=TRUE)
{
  if (!requireNamespace("ggplot2", quietly=TRUE) | exists(x="is.test.environment"))
    stop("ggplot2 is required for plotting. Please install")

  transform <- match.arg(transform)
  if (is.null(limits))
    limits <- if (transform=="log10") c(NA,1) else c(0,1)
  if (is.null(breaks))
    breaks <- if (transform=="log10") 10**seq(from=-5, to=0, length.out=6) else seq(from=0, to=1, length.out=6)
  if (is.null(data.samples))
    data.samples <- colnames(GenomicRanges::mcols(data.ranges))

  amr.ranges.reduced  <- GenomicRanges::reduce(amr.ranges, min.gapwidth=window, with.revmap=TRUE, ignore.strand=ignore.strand)
  amr.ranges.relisted <- BiocGenerics::relist(amr.ranges[unlist(amr.ranges.reduced$revmap)], amr.ranges.reduced$revmap)

  if (verbose) message("Plotting ", length(amr.ranges.reduced), " genomic ranges ", appendLF=FALSE)
  tm <- proc.time()

  data.ranges.dt <- data.table::as.data.table(data.ranges[, data.samples], optional=TRUE)
  plot.list <- list()

  for (i in seq_along(amr.ranges.relisted)) {
    plot.ranges <- unlist(amr.ranges.relisted[i])
    if (!is.null(plot.ranges$dbeta))
      plot.ranges <- plot.ranges[order(plot.ranges$dbeta, decreasing=TRUE)]
    # plot.key <- data.table::as.data.table(GenomicRanges::reduce(plot.ranges, ignore.strand=ignore.strand))
    plot.key <- data.table::as.data.table(GenomicRanges::granges(plot.ranges))
    plot.key[, `:=` (start=start-window, end=end+window)]
    data.table::setkeyv(plot.key, c(if (ignore.strand) NULL else "strand", "seqnames", "start", "end"))

    data.hits <- unique(data.table::foverlaps(data.ranges.dt, plot.key, mult="all", nomatch=NULL, which=TRUE)$xid)
    # old.data.hits <- unique(S4Vectors::queryHits(GenomicRanges::findOverlaps(data.ranges, plot.ranges, maxgap=window, ignore.strand=ignore.strand)))
    # if (!identical(data.hits, old.data.hits)) stop("different hits")
    revmap.hits <- unique(unlist(plot.ranges$revmap, recursive=TRUE, use.names=FALSE))
    if (!all(revmap.hits %in% data.hits))
      stop("AMRs don't map to 'data.ranges'! Was the 'data.ranges' object modified after AMR search?")
    if (length(data.hits)>0) {
      plot.data <- data.ranges.dt[data.hits]
      plot.data$median <- apply(plot.data[, ..data.samples], 1, stats::median, na.rm=TRUE)

      amr.samples <- na.omit(plot.ranges$sample)
      amr.revmaps <- plot.ranges$revmap

      colorify       <- c("median", if (is.null(highlight)) unique(as.character(amr.samples)), highlight)
      plot.data.melt <- data.table::melt.data.table(plot.data, id.vars=c("seqnames","start","end","width","strand"),
                                                    variable.name="sample", value.name="beta")
      plot.data.melt[, `:=` (
        size=0,
        alpha=0.5,
        color=factor("lightgrey",levels=c("lightgrey", colorify))
      )]

      plot.data.melt[sample %in% colorify, `:=` (alpha=0.9, color=sample)]
      for (j in seq_along(plot.ranges)) {
        plot.data.melt[sample %in% amr.samples[j] & start %in% data.ranges.dt[amr.revmaps[[j]], start],
                       size:=1]
      }

      plot.title <- if (is.null(title)) as.character(GenomicRanges::reduce(plot.ranges, min.gapwidth=window, ignore.strand=ignore.strand)) else title
      gene.plot <- ggplot2::ggplot(plot.data.melt, ggplot2::aes(x=start, y=beta, group=sample, color=color, alpha=alpha)) +
        ggplot2::geom_line(linewidth=0.5) +
        ggplot2::geom_point(mapping=ggplot2::aes(size=size)) +
        ggplot2::scale_x_continuous(name=labs[1]) +
        ggplot2::scale_y_continuous(name=labs[2], limits=limits, breaks=breaks, transform=transform) +
        ggplot2::scale_color_discrete(name="samples", limits=colorify) +
        ggplot2::scale_alpha_continuous(guide="none") +
        ggplot2::scale_size_identity(guide="none") +
        ggplot2::guides(color=ggplot2::guide_legend(ncol=1)) +
        ggplot2::theme_light() +
        ggplot2::theme(legend.text=ggplot2::element_text(size=8),
                       axis.text.x=ggplot2::element_text(size=8, angle=0),
                       axis.text.y=ggplot2::element_text(size=8)) +
        ggplot2::ggtitle(plot.title)

      plot.list <- c(plot.list, stats::setNames(c(list(gene.plot)), plot.title))
    }

    if (verbose) cat(sprintf("%3.0f%%\b\b\b\b", 100*i/length(amr.ranges.relisted)))
  }

  if (verbose) message(sprintf("[%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
  return(plot.list)
}

test_plotAMR <- function () {
  data(ramr)

  RUnit::checkException(
    plotAMR(data.ranges=sort(ramr.data, decreasing=TRUE), amr.ranges=ramr.tp.nonunique)
  )

  RUnit::checkEquals(
    length(plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.nonunique)),
    length(GenomicRanges::reduce(ramr.tp.nonunique))
  )
  RUnit::checkEquals(
    length(plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.unique)),
    length(GenomicRanges::reduce(ramr.tp.unique))
  )

  ### if suggested library is not available
  test.env <- new.env()
  assign(x="is.test.environment", value=TRUE, envir=test.env)
  test.func <- function(f, env, ...) {
    environment(f) <- env
    f(...)
  }
  RUnit::checkException(
    test.func(f=plotAMR, env=test.env, data.ranges=ramr.data, amr.ranges=ramr.tp.nonunique)
  )
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

rcpp_compute_logp_beta <- function(data) {
    .Call(`_ramr_rcpp_compute_logp_beta`, data)
}

rcpp_compute_logp_beta_binom <- function(data) {
    .Call(`_ramr_rcpp_compute_logp_beta_binom`, data)
}

rcpp_compute_xiqr <- function(data) {
    .Call(`_ramr_rcpp_compute_xiqr`, data)
}

rcpp_create_granges_stranded_xiqr <- function(data, window, min_ncpg, min_width) {
    .Call(`_ramr_rcpp_create_granges_stranded_xiqr`, data, window, min_ncpg, min_width)
}

rcpp_create_granges_stranded_logp <- function(data, window, min_ncpg, min_width) {
    .Call(`_ramr_rcpp_create_granges_stranded_logp`, data, window, min_ncpg, min_width)
}

rcpp_create_granges_unstranded_xiqr <- function(data, window, min_ncpg, min_width) {
    .Call(`_ramr_rcpp_create_granges_unstranded_xiqr`, data, window, min_ncpg, min_width)
}

rcpp_create_granges_unstranded_logp <- function(data, window, min_ncpg, min_width) {
    .Call(`_ramr_rcpp_create_granges_unstranded_logp`, data, window, min_ncpg, min_width)
}

rcpp_filter_threshold_xiqr <- function(data, thrshld) {
    .Call(`_ramr_rcpp_filter_threshold_xiqr`, data, thrshld)
}

rcpp_filter_threshold_logp <- function(data, thrshld) {
    .Call(`_ramr_rcpp_filter_threshold_logp`, data, thrshld)
}

rcpp_fit_beta_mom <- function(data) {
    .Call(`_ramr_rcpp_fit_beta_mom`, data)
}

rcpp_fit_beta_amle <- function(data) {
    .Call(`_ramr_rcpp_fit_beta_amle`, data)
}

rcpp_fit_binom <- function(data) {
    .Call(`_ramr_rcpp_fit_binom`, data)
}

rcpp_generate_random_values <- function(data, ncol) {
    .Call(`_ramr_rcpp_generate_random_values`, data, ncol)
}

rcpp_get_iqr <- function(data) {
    .Call(`_ramr_rcpp_get_iqr`, data)
}

rcpp_get_meanvar_ari_equal <- function(data) {
    .Call(`_ramr_rcpp_get_meanvar_ari_equal`, data)
}

rcpp_get_meanvar_ari_invDist <- function(data) {
    .Call(`_ramr_rcpp_get_meanvar_ari_invDist`, data)
}

rcpp_get_meanvar_ari_sqrtInvDist <- function(data) {
    .Call(`_ramr_rcpp_get_meanvar_ari_sqrtInvDist`, data)
}

rcpp_get_meanvar_ari_logInvDist <- function(data) {
    .Call(`_ramr_rcpp_get_meanvar_ari_logInvDist`, data)
}

rcpp_get_meanvar_geo_equal <- function(data) {
    .Call(`_ramr_rcpp_get_meanvar_geo_equal`, data)
}

rcpp_get_meanvar_geo_invDist <- function(data) {
    .Call(`_ramr_rcpp_get_meanvar_geo_invDist`, data)
}

rcpp_get_meanvar_geo_sqrtInvDist <- function(data) {
    .Call(`_ramr_rcpp_get_meanvar_geo_sqrtInvDist`, data)
}

rcpp_get_meanvar_geo_logInvDist <- function(data) {
    .Call(`_ramr_rcpp_get_meanvar_geo_logInvDist`, data)
}

rcpp_extract_out <- function(data) {
    .Call(`_ramr_rcpp_extract_out`, data)
}

rcpp_extract_coef <- function(data) {
    .Call(`_ramr_rcpp_extract_coef`, data)
}

rcpp_prepare_data_identity <- function(seqnames, seqrunlens, start, strand, mcols, coverage, exclude_lower, exclude_upper, chunks) {
    .Call(`_ramr_rcpp_prepare_data_identity`, seqnames, seqrunlens, start, strand, mcols, coverage, exclude_lower, exclude_upper, chunks)
}

rcpp_prepare_data_linear <- function(seqnames, seqrunlens, start, strand, mcols, coverage, exclude_lower, exclude_upper, chunks) {
    .Call(`_ramr_rcpp_prepare_data_linear`, seqnames, seqrunlens, start, strand, mcols, coverage, exclude_lower, exclude_upper, chunks)
}

rcpp_test_omp <- function() {
    .Call(`_ramr_rcpp_test_omp`)
}

## ----include = FALSE------------------------------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  width = 100
)
options(width=100)

## ----fig.width=10, fig.height=4, out.width="100%", out.height="100%"------------------------------
library(GenomicRanges)
library(ggplot2)
library(ramr)
data(ramr)

head(ramr.samples)
ramr.data[1:10,ramr.samples[1:3]]
plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.unique[1])
plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.nonunique[c(1,6,11)])

## ----fig.width=10, fig.height=6, out.width="100%", out.height="100%"------------------------------
# set the seed if reproducible results required
  set.seed(999)

# unique random AMRs
  amrs.unique <-
    simulateAMR(template.ranges=ramr.data, nsamples=25, regions.per.sample=2,
                min.cpgs=5, merge.window=1000, dbeta=0.2)

# non-unique AMRs outside of regions with unique AMRs
  amrs.nonunique <-
    simulateAMR(template.ranges=ramr.data, nsamples=4, exclude.ranges=amrs.unique,
                sample.names=sprintf("sample%02i", c(2, 4, 8, 16)),
                samples.per.region=2, min.cpgs=5, merge.window=1000)
  
# random noise outside of AMR regions
  noise <-
    simulateAMR(ramr.data, nsamples=25, regions.per.sample=20,
                exclude.ranges=c(amrs.unique, amrs.nonunique),
                min.cpgs=1, max.cpgs=1, merge.window=1, dbeta=0.5)

# "smooth" methylation data without AMRs (negative control)
  smooth.data <-
    simulateData(template.ranges=ramr.data, nsamples=25)
  
# methylation data with AMRs and noise
  noisy.data <-
    simulateData(template.ranges=ramr.data, nsamples=25,
                 amr.ranges=c(amrs.unique, amrs.nonunique, noise))
  
# that's how regions look like
  library(gridExtra)

  do.call("grid.arrange", c(plotAMR(data.ranges=noisy.data, amr.ranges=amrs.unique[1:4]), ncol=2))
  do.call("grid.arrange", c(plotAMR(data.ranges=noisy.data, amr.ranges=sort(amrs.nonunique)[1:8]), ncol=2))
  do.call("grid.arrange", c(plotAMR(data.ranges=noisy.data, amr.ranges=noise[1:4]), ncol=2))
  
# can we find them?
  system.time(
    found <- getAMR(
      data.ranges=noisy.data,
      compute="beta+binom", compute.estimate="amle", compute.weights="logInvDist",
      combine.min.cpgs=5, combine.threshold=1e-2, combine.window=1000
    )
  )
  
# all possible regions
  all.ranges <- getUniverse(noisy.data, min.cpgs=5, merge.window=1000)
  
# true positives
  tp <- sum(found %over% c(amrs.unique, amrs.nonunique))
  
# false positives
  fp <- sum(found %outside% c(amrs.unique, amrs.nonunique))

# true negatives
  tn <- length(all.ranges %outside% c(amrs.unique, amrs.nonunique))
  
# false negatives
  fn <- sum(c(amrs.unique, amrs.nonunique) %outside% found)
  
# accuracy, MCC
  acc <- (tp+tn) / (tp+tn+fp+fn)
  mcc <- (tp*tn - fp*fn) / (sqrt(tp+fp)*sqrt(tp+fn)*sqrt(tn+fp)*sqrt(tn+fn))
  setNames(c(tp, fp, tn, fn), c("TP", "FP", "TN", "FN"))
  setNames(c(acc, mcc), c("accuracy", "MCC"))

## ----fig.width=10, fig.height=6, out.width="100%", out.height="100%"------------------------------
# identify AMRs
amrs <- getAMR(
  data.ranges=ramr.data, data.samples=ramr.samples, compute="beta+binom",
      combine.min.cpgs=5, combine.threshold=1e-2, combine.window=1000
)

# inspect
sort(amrs)

do.call("grid.arrange", c(plotAMR(data.ranges=ramr.data, amr.ranges=amrs[1:10]), ncol=2))

## -------------------------------------------------------------------------------------------------
# annotating AMRs using R library annotatr
library(annotatr)
annotation.types <- c("hg19_cpg_inter", "hg19_cpg_islands", "hg19_cpg_shores",
                      "hg19_cpg_shelves", "hg19_genes_intergenic", "hg19_genes_promoters",
                      "hg19_genes_5UTRs", "hg19_genes_firstexons", "hg19_genes_3UTRs")
annotations <- build_annotations(genome='hg19', annotations=annotation.types)
amrs.annots <- annotate_regions(regions=amrs, annotations=annotations, ignore.strand=TRUE, quiet=FALSE)
summarize_annotations(annotated_regions=amrs.annots, quiet=FALSE)

## ----session--------------------------------------------------------------------------------------
sessionInfo()

#' Template-based simulation of methylation data sets
#'
#' @description
#' `simulateData` generates aberration-free methylation data using an
#' experimental data set as a template, and further introduces methylation
#' aberrations if `GRanges` object containing a set of aberrantly methylated
#' regions was provided. The output can be used to evaluate performance
#' of algorithms for search of differentially (DMR) or aberrantly (AMR)
#' methylated regions.
#'
#' @details
#' For every genomic location in the template data set (`GRanges` object with
#' genomic locations and corresponding methylation beta values included as
#' metadata) `simulateData` does the following:
#' \itemize{
#'   \item estimates parameters of beta distribution
#'   \item in the same input, calculates frequencies of zero and one values
#'   (endpoints; whenever present)
#'   \item uses estimated parameters of beta distribution and probabilities
#'   (observed frequencies) of \{0;1\} values to generate `nsamples` random
#'   values by means of `stats::rbeta` function (for beta values) and/or
#'   `stats::rbinom` function (for \{0;1\} endpoint values, according to their
#'   frequencies and therefore probabilities).
#' }
#' This results in "smoothed" data set that has biologically relevant
#' distribution of methylation values at every genomic location,
#' but does not contain methylation
#' aberrations. If the `amr.ranges` parameter points to a `GRanges` object with
#' aberrations, every AMR is then introduced into the "smoothed" data set as
#' following: if mean methylation beta value for AMR region across all samples
#' in the "smoothed" data set is above (below) 0.5 then all beta values for the
#' sample defined by the `sample` metadata column are decreased (increased) by
#' the absolute value specified in the `dbeta` metadata column. Resulting
#' data sets with (or without) AMR together with the `amr.ranges` set of true
#' positive aberrations can be used as test data set to evaluate performance
#' of algorithms for search of differentially (DMR) or aberrantly (AMR)
#' methylated regions.
#'
#' @note
#' NA values within metadata columns of `template.ranges` are silently dropped
#' in all computations. NA values will also not appear in the result of
#' this function, unless parameters of beta distribution and/or probabilities
#' of zeros or ones cannot be estimated (e.g., due to too many NA values in
#' `template.ranges` metadata).
#'
#' @param template.ranges A `GRanges` object with genomic locations and
#' corresponding methylation beta values included as metadata (the same object
#' must be supplied to this and to the `simulateAMR` functions).
#' @param nsamples A single integer >= 1 indicating the number of samples to
#' generate.
#' @param amr.ranges A `GRanges` object with genomic locations of methylation
#' aberrations (epimutations). If `NULL` (the default), no aberrations is
#' introduced, and function will return "smoothed" data set. If supplied,
#' `GRanges` object must contain the following metadata columns:
#' \itemize{
#'   \item `revmap` -- integer list of `template.ranges` genomic locations that
#'   are included in this AMR region
#'   \item `sample` -- an identifier of a sample to which corresponding AMR
#'   belongs. Must be among the supplied or auto generated `sample.names`
#'   \item `dbeta` -- absolute deviation to be introduced. Must be numeric
#'   within the closed interval [0,1] or NA. When NA - the resulting beta value
#'   for the corresponding genomic position will also be NA
#' }
#' Such an object can be obtained using \code{\link{simulateAMR}} method or
#' manually.
#' @param sample.names A character vector with sample names. If `NULL` (the
#' default), sample names will be auto generated. When specified, the length
#' of the `sample.names` vector must be equal to the value of `nsamples`.
#' @param compute A single string for the distribution to fit to the data.
#' Currently accepts "beta+binom" (the default) only, which stands for
#' endpoint-inflated beta distribution. See Details section
#' and \code{\link{getAMR}} method description for additional explanations.
#' @param compute.estimate A single string for the method of parameter
#' estimation of beta distribution. The default ("mom") stands for the method
#' of moments based on the unbiased estimator of variance and includes \{0;1\}
#' endpoints in calculation of moments (mean, unbiased variance).
#' Other options are "amle" (approximation of maximum likelihood estimation)
#' and "nmle" (numeric maximum likelihood estimation) - both ignore \{0;1\}
#' endpoints in calculations. More details on these methods are given in
#' \code{\link{getAMR}} method description.
#' @param compute.weights A single string for the method to compute optional
#' sample weights that are used during estimation of beta distribution
#' parameters. If default ("equal"), all weights are equal. Otherwise, weight of
#' a value equals to a natural logarithm of inverse absolute distance of this
#' value to the sample median ("logInvDist"), a square root of inverse absolute
#' distance of this value to the sample median ("sqrtInvDist"), or an inverse
#' absolute distance of this value to the sample median ("invDist"). Using
#' weighted parameter estimation allows to increase sensitivity of outlier
#' detection. More details on weighted parameter estimation are given in
#' \code{\link{getAMR}} method description.
#' @param ncores A single integer >= 1 for the number of OpenMP threads for
#' parallel computation. By default (NULL), function will use half of available
#' cores. When the same random seed is set, results of this function are always
#' identical (reproducible), even when more than one core is used (at a cost
#' of serial random number generation).
#' @param verbose boolean to report progress and timings (default: TRUE).
#' @return The output is a `GRanges` object with genomic ranges that are equal
#' to the genomic ranges of the provided template and metadata columns
#' containing generated methylation beta values for `nsamples` samples. If
#' `amr.ranges` object was supplied, then randomly generated beta values will be
#' modified accordingly.
#' @seealso \code{\link{simulateAMR}} for the generation of random methylation
#' aberrations, \code{\link{getAMR}} for identification of AMRs,
#' \code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
#' for info on enrichment analysis, and `ramr` vignettes for the description of
#' usage and sample data.
#' @examples
#'   data(ramr)
#'   set.seed(1)
#'   amrs <-
#'     simulateAMR(ramr.data, nsamples=10, regions.per.sample=3,
#'                 samples.per.region=1, min.cpgs=5, merge.window=1000)
#'   noise <-
#'     simulateAMR(ramr.data, nsamples=10, regions.per.sample=20,
#'                 exclude.ranges=amrs, min.cpgs=1, max.cpgs=1, merge.window=1)
#'   noisy.data <-
#'     simulateData(template.ranges=ramr.data, nsamples=10, amr.ranges=c(amrs,noise))
#'   plotAMR(data.ranges=noisy.data, amr.ranges=amrs[1])
#' @export
simulateData <- function (template.ranges,
                          nsamples,
                          amr.ranges=NULL,
                          sample.names=NULL,
                          compute="beta+binom",
                          compute.estimate=c("mom", "amle", "nmle"),
                          compute.weights=c("equal", "logInvDist", "sqrtInvDist", "invDist"),
                          ncores=NULL,
                          verbose=TRUE)
{
  if (!methods::is(template.ranges,"GRanges"))
    stop("'template.ranges' must be a GRanges object")
  if (!is.null(sample.names) & length(sample.names)!=nsamples)
    stop("'sample.names' length must be equal to 'nsamples'")

  if (is.null(sample.names))
    sample.names <- sprintf(paste0("sample%0", nchar(as.character(nsamples)), "i"), seq_len(nsamples))
  if (!is.null(amr.ranges)) {
    if(!methods::is(amr.ranges,"GRanges"))
      stop("'amr.ranges' must be a GRanges object")
    if ( is.null(amr.ranges$revmap) | !all(unlist(amr.ranges$revmap) %in% seq_along(template.ranges)) )
      stop("Malformed 'amr.ranges' object: 'revmap' field is missing or contains out-of-range values")
    if ( is.null(amr.ranges$sample) | !all(amr.ranges$sample %in% sample.names) )
      stop("Malformed 'amr.ranges' object: 'sample' field is missing or its elements are absent from 'sample.names'")
    if ( !is.numeric(amr.ranges$dbeta) | !all(stats::na.omit(amr.ranges$dbeta)>=0) | !all(stats::na.omit(amr.ranges$dbeta)<=1) )
      stop("Malformed 'amr.ranges' object: 'dbeta' field is missing or is outside the closed interval [0,1]")
  }

  template.mcols <- GenomicRanges::mcols(template.ranges)
  template.samples <- colnames(template.mcols)
  template.coverage <- as.data.frame( sapply(template.samples, function (s) integer(0)) )
  compute.estimate <- match.arg(compute.estimate)
  compute.weights <- match.arg(compute.weights)

  if (compute.estimate=="nmle")
    stop("compute.estimate=='nmle' is not available yet")

  #####################################################################################

  .data <- .preprocessData(
    data.ranges=template.ranges, data.samples=template.samples,
    data.coverage=template.coverage, transform="identity",
    exclude.range=c(2,0), ncores=ncores, verbose=verbose
  )

  random.betas <- .getRandomValues(
    data.list=.data, estimate=compute.estimate, weights=compute.weights,
    nsamples=nsamples, sample.names=sample.names, verbose=verbose
  )

  if (!is.null(amr.ranges)) {
    random.betas <- .addEpimutations(
      random.data=random.betas, amr.ranges=amr.ranges, verbose=verbose
    )
  }

  data.ranges <- GenomicRanges::granges(template.ranges)
  GenomicRanges::mcols(data.ranges) <- random.betas

  return(data.ranges)
}

#' [OBSOLETE] Search for aberrantly methylated regions
#'
#' @description
#' This function is fully functional but obsolete. It will remain a part of the
#' package for consistency, as it was used in `ramr` publication
#' (\doi{10.1093/bioinformatics/btab586}). Please use faster and more capable
#' \code{\link{getAMR}} instead.
#'
#' `getAMR.obsolete` returns a `GRanges` object with all the aberrantly
#' methylated regions (AMRs) for all samples in a data set.
#'
#' @details
#' In the provided data set, `getAMR.obsolete` compares methylation beta values
#' of each sample with other samples to identify rare long-range methylation
#' aberrations (epimutations).
#' For `ramr.method=="IQR"`: for every genomic location (CpG) in
#' `data.ranges` the IQR-normalized deviation from the median value is
#' calculated, and all CpGs with such normalized deviation not smaller than the
#' `iqr.cutoff` are retained. For
#' `ramr.method %in% c("beta", "wbeta", "beinf")`: parameters of beta
#' distribution are estimated by means of `EnvStats::ebeta` (beta distribution),
#' `ExtDist::eBeta` (weighted beta destribution), or `gamlss.dist::BEINF` (zero
#' and one inflated beta distribution) functions, respectively. These
#' parameters are then used to calculate the probability values, followed by the
#' filtering when all CpGs with p-values not greater than `qval.cutoff` are
#' retained. Another filtering is then performed to exclude all CpGs within
#' `exclude.range`. Next, the retained (significant) CpGs are merged within
#' the window of `merge.window`, and final filtering is applied to AMR genomic
#' ranges (by `min.cpgs` and `min.width`).
#'
#' @param data.ranges A `GRanges` object with genomic locations and
#' corresponding beta values included as metadata.
#' @param data.samples A character vector with sample names (a subset of
#' metadata column names). If `NULL` (the default), then all samples (metadata
#' columns) are included in the analysis.
#' @param ramr.method A character scalar: when ramr.method is "IQR" (the
#' default), the filtering based on interquantile range is used (`iqr.cutoff`
#' value is then used as a threshold). When "beta", "wbeta" or "beinf" -
#' filtering based on fitting non-weighted (`EnvStats::ebeta`), weighted
#' (`ExtDist::eBeta`) or zero-and-one inflated (`gamlss.dist::BEINF`)
#' beta distributions, respectively, is used, and `pval.cutoff` or `qval.cutoff`
#' (if not `NULL`) is used as a threshold. For "wbeta", weights directly
#' correlate with bin contents (number of values per bin) and inversly - with
#' the distances from the median value, thus narrowing the estimated
#' distribution and emphasizing outliers.
#' @param iqr.cutoff A single integer >= 1. Methylation beta values differing
#' from the median value by more than `iqr.cutoff` interquartile ranges are
#' considered to be significant (the default: 5).
#' @param pval.cutoff A numeric scalar (the default: 5e-2). Bonferroni
#' correction of `pval.cutoff` by the length of the `data.samples` object is
#' used to calculate `qval.cutoff` if the latter is `NULL`.
#' @param qval.cutoff A numeric scalar. Used as a threshold for filtering based
#' on fitting non-weighted or weighted beta distributions: all p-values lower
#' than `qval.cutoff` are considered to be significant. If `NULL` (the default),
#' it is calculated using `pval.cutoff`
#' @param merge.window A positive integer. All significant (survived the
#' filtering stage) `data.ranges` genomic locations within this distance will be
#' merged to create AMRs (the default: 300).
#' @param min.cpgs A single integer >= 1. All AMRs containing less than
#' `min.cpgs` significant genomic locations are filtered out (the default: 7).
#' @param min.width A single integer >= 1 (the default). Only AMRs with the
#' width of at least `min.width` are returned.
#' @param exclude.range A numeric vector of length two. If not `NULL` (the
#' default), all `data.ranges` genomic locations with their median methylation
#' beta value within the `exclude.range` interval are filtered out.
#' @param cores A single integer >= 1. Number of processes for parallel
#' computation (the default: all but one cores). Results of parallel processing
#' are fully reproducible when the same seed is used (thanks to doRNG).
#' @param verbose boolean to report progress and timings (default: TRUE).
#' @param ... Further arguments to be passed to `EnvStats::ebeta` or
#' `ExtDist::eBeta` functions.
#' @return The output is a `GRanges` object that contains all the aberrantly
#' methylated regions (AMRs) for all `data.samples` samples in `data.ranges`
#' object. The following metadata columns may be present:
#' \itemize{
#'   \item `revmap` -- integer list of significant CpGs (`data.ranges` genomic
#'   locations) that are included in this AMR region
#'   \item `ncpg` -- number of significant CpGs within this AMR region
#'   \item `sample` -- contains an identifier of a sample to which
#'   corresponding AMR belongs
#'   \item `dbeta` -- average deviation of beta values for significant CpGs from
#'   their corresponding median values
#'   \item `pval` -- geometric mean of p-values for significant CpGs
#'   \item `xiqr` -- average IQR-normalised deviation of beta values for
#'   significant CpGs from their corresponding median values
#' }
#' @seealso \code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
#' for info on enrichment analysis, \code{\link{simulateAMR}} and
#' \code{\link{simulateData}} for the generation of simulated test data sets,
#' and `ramr` vignettes for the description of usage and sample data.
#' @examples
#'   data(ramr)
#'   getAMR.obsolete(ramr.data, ramr.samples, ramr.method="beta",
#'                   min.cpgs=5, merge.window=1000, qval.cutoff=1e-3, cores=2)
#' @export
getAMR.obsolete <- function (data.ranges,
                             data.samples=NULL,
                             ramr.method=c("IQR", "beta", "wbeta", "beinf"),
                             iqr.cutoff=5,
                             pval.cutoff=5e-2,
                             qval.cutoff=NULL,
                             merge.window=300,
                             min.cpgs=7,
                             min.width=1,
                             exclude.range=NULL,
                             cores=max(1,parallel::detectCores()-1),
                             verbose=TRUE,
                             ...)
{
  if (interactive() | Sys.getenv("R_COVR")!="")
    message("This function is fully functional but *obsolete*.\n",
            "Please use faster and more capable 'getAMR' instead.\n")
  for (ns in c("EnvStats", "ExtDist", "gamlss", "gamlss.dist", "doParallel",
               "parallel", "doRNG", "foreach", "matrixStats"))
    if (!requireNamespace(ns, quietly=TRUE) | exists(x="is.test.environment"))
      stop(ns, " is required for this function. Please install")
  `%dorng%` <- doRNG::`%dorng%`

  if (!methods::is(data.ranges,"GRanges"))
    stop("'data.ranges' must be a GRanges object")
  if (is.null(data.samples))
    data.samples <- colnames(GenomicRanges::mcols(data.ranges))
  if (!all(data.samples %in% colnames(GenomicRanges::mcols(data.ranges))))
    stop("'data.ranges' metadata must include 'data.samples'")
  if (length(data.samples)<3)
    stop("at least three 'data.samples' must be provided")
  ramr.method <- match.arg(ramr.method)

  #####################################################################################

  getPValues.beta <- function (data.chunk, ...) {
    chunk.filt <- apply(data.chunk, 1, function (x) {
      x.median    <- stats::median(x, na.rm=TRUE)
      x[is.na(x)] <- x.median
      beta.fit <- suppressWarnings( EnvStats::ebeta(as.numeric(x), ...) )
      pvals    <- stats::pbeta(x, beta.fit$parameters[1], beta.fit$parameters[2])
      pvals[x>x.median] <- 1 - pvals[x>x.median]
      return(pvals)
    })
    return(t(chunk.filt))
  }
  getPValues.wbeta<- function (data.chunk, ...) {
    chunk.filt  <- apply(data.chunk, 1, function (x) {
      x.median    <- stats::median(x, na.rm=TRUE)
      x[is.na(x)] <- x.median
      # weight directly correlates with bin contents (number of values per bin)
      # and inversely - with the distance from the median value, thus narrowing
      # the estimated distribution and emphasizing outliers
      c           <- cut(x, c(0:100)/100)
      b           <- table(c)
      w           <- as.numeric(b[c]) * (1 - abs(x-x.median))
      beta.fit    <- suppressWarnings( ExtDist::eBeta(as.numeric(x), w, ...) )
      pvals       <- ExtDist::pBeta(x, params=beta.fit)
      pvals[x>x.median] <- 1 - pvals[x>x.median]
      return(pvals)
    })
    return(t(chunk.filt))
  }
  inv.logit <- function (x) exp(x)/(1+exp(x))
  getPValues.beinf <- function (data.chunk, ...) {
    chunk.filt <- apply(data.chunk, 1, function (x) {
      x.median    <- stats::median(x, na.rm=TRUE)
      x[is.na(x)] <- x.median
      beinf.fit <- gamlss::gamlss(
        as.numeric(x)~1, sigma.formula=~1, nu.formula=~1, tau.formula=~1,
        family=gamlss.dist::BEINF(mu.link="logit", sigma.link="logit",
                                  nu.link="log", tau.link="log"),
        control=gamlss::gamlss.control(trace=FALSE), ...
      )
      pvals <- gamlss.dist::pBEINF(
        q=x, mu=inv.logit(beinf.fit$mu.coefficients),
        sigma=inv.logit(beinf.fit$sigma.coefficients),
        nu=exp(beinf.fit$nu.coefficients),
        tau=exp(beinf.fit$tau.coefficients),
        lower.tail=TRUE, log.p=FALSE
      )
      pvals[x>x.median] <- 1 - pvals[x>x.median]
      return(pvals)
    })
    return(t(chunk.filt))
  }


  #####################################################################################

  if (verbose) message("Identifying AMRs", appendLF=FALSE)
  tm <- proc.time()

  doParallel::registerDoParallel(cores)
  cl <- parallel::makeCluster(cores)

  universe      <- getUniverse(data.ranges, merge.window=merge.window, min.cpgs=min.cpgs, min.width=min.width)
  universe.cpgs <- unlist(universe$revmap)

  betas <- as.matrix(mcols(data.ranges)[universe.cpgs, data.samples, drop=FALSE])
  if (is.null(qval.cutoff))
    qval.cutoff <- pval.cutoff/ncol(betas)

  chunks  <- split(seq_len(nrow(betas)), if (cores>1) cut(seq_len(nrow(betas)), cores) else 1)
  medians <- foreach::foreach (chunk=chunks, .combine=c) %dorng% matrixStats::rowMedians(betas[chunk, ], na.rm=TRUE)

  if (ramr.method=="IQR") {
    iqrs <- foreach::foreach (chunk=chunks, .combine=c) %dorng% matrixStats::rowIQRs(betas[chunk, ], na.rm=TRUE)
    betas.filtered <- (betas-medians)/iqrs
    betas.filtered[abs(betas.filtered)<iqr.cutoff]  <- NA
  } else if (ramr.method=="beta") {
    # multi-threaded EnvStats::ebeta (speed: mme=mmue>mle>>>fitdistrplus::fitdist)
    betas.filtered <- foreach::foreach (chunk=chunks) %dorng% getPValues.beta(betas[chunk, ], ...)
    betas.filtered <- do.call(rbind, betas.filtered)
    betas.filtered[betas.filtered>=qval.cutoff] <- NA
  } else if (ramr.method=="wbeta") {
    betas.filtered <- foreach::foreach (chunk=chunks) %dorng% getPValues.wbeta(betas[chunk, ], ...)
    betas.filtered <- do.call(rbind, betas.filtered)
    betas.filtered[betas.filtered>=qval.cutoff] <- NA
  } else if (ramr.method=="beinf") {
    betas.filtered <- foreach::foreach (chunk=chunks) %dorng% getPValues.beinf(betas[chunk, ], ...)
    betas.filtered <- do.call(rbind, betas.filtered)
    betas.filtered[betas.filtered>=qval.cutoff] <- NA
  }

  if (!is.null(exclude.range))
    betas.filtered[medians>=exclude.range[1] & medians<=exclude.range[2]] <- NA


  getMergedRanges <- function (column) {
    not.na <- which(!is.na(betas.filtered[,column]))
    ranges <- GenomicRanges::reduce(data.ranges[universe.cpgs[not.na]], min.gapwidth=merge.window, with.revmap=TRUE)
    if (length(ranges)>0) {
      ranges$ncpg   <- unlist(lapply(ranges$revmap, length))
      ranges$sample <- column
      ranges        <- subset(ranges, `ncpg`>=min.cpgs & `width`>=max(1,min.width))
      ranges$dbeta  <- vapply(ranges$revmap, function (revmap) {
        mean(betas[not.na[revmap],column,drop=FALSE] - medians[not.na[revmap]])
      }, numeric(1))

      if (ramr.method=="IQR") {
        ranges$xiqr   <- vapply(ranges$revmap, function (revmap) {
          mean(betas.filtered[not.na[revmap],column,drop=FALSE], na.rm=TRUE)
        }, numeric(1))
      } else {
        ranges$pval <- vapply(ranges$revmap, function (revmap) {
          return( 10**mean(log10(betas.filtered[not.na[revmap],column] + .Machine$double.xmin), na.rm=TRUE) )
        }, numeric(1))
      }

      ranges$revmap <- lapply(ranges$revmap, function (i) {universe.cpgs[not.na[i]]})
    }
    return(ranges)
  }

  amr.ranges <- foreach::foreach (column=colnames(betas.filtered)) %dorng% getMergedRanges(column)

  parallel::stopCluster(cl)
  if (verbose) message(sprintf(" [%.3fs]",(proc.time()-tm)[3]), appendLF=TRUE)
  return(unlist(methods::as(amr.ranges, "GRangesList")))
}

test_getAMR.obsolete <- function () {
  data(ramr)

  RUnit::checkException(
    getAMR.obsolete(c())
  )
  RUnit::checkException(
    getAMR.obsolete(ramr.data, ramr.samples[1:2])
  )
  RUnit::checkException(
    getAMR.obsolete(ramr.data, c("a","b","c"))
  )
  RUnit::checkException(
    getAMR.obsolete(ramr.data, ramr.samples, ramr.method="zzz")
  )

  amr.iqr.1 <- getAMR.obsolete(ramr.data, ramr.method="IQR", min.cpgs=5, merge.window=10000, iqr.cutoff=5, cores=1)
  amr.iqr.2 <- getAMR.obsolete(ramr.data, ramr.method="IQR", min.cpgs=5, merge.window=10000, iqr.cutoff=5, cores=2)
  RUnit::checkIdentical(
    amr.iqr.1,
    amr.iqr.2
  )
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.iqr.2, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.iqr.2, ramr.tp.nonunique))),
    c(6, 45)
  )

  amr.beta <- getAMR.obsolete(ramr.data, ramr.samples, ramr.method="beta", min.cpgs=5, merge.window=10000, qval.cutoff=1e-3, cores=2)
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.beta, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.beta, ramr.tp.nonunique))),
    c(6, 45)
  )

  amr.wbeta <- getAMR.obsolete(ramr.data, ramr.samples, ramr.method="wbeta", min.cpgs=5, merge.window=10000, qval.cutoff=1e-4, cores=2)
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.wbeta, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.wbeta, ramr.tp.nonunique))),
    c(6, 45)
  )

  amr.iqr.3 <- getAMR.obsolete(ramr.data, ramr.samples, ramr.method="IQR", min.cpgs=5, merge.window=10000, cores=2, exclude.range=c(0.1,0.9))
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.iqr.3, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.iqr.3, ramr.tp.nonunique))),
    c(2, 18)
  )

  amr.beinf <- getAMR.obsolete(ramr.data, ramr.samples, ramr.method="beinf", min.cpgs=5, merge.window=10000, qval.cutoff=1e-3, cores=2)
  RUnit::checkEquals(
    c(sum(GenomicRanges::countOverlaps(amr.beinf, ramr.tp.unique)), sum(GenomicRanges::countOverlaps(amr.beinf, ramr.tp.nonunique))),
    c(6, 45)
  )

  ### if suggested library is not available
  test.env <- new.env()
  assign(x="is.test.environment", value=TRUE, envir=test.env)
  test.func <- function(f, env, ...) {
    environment(f) <- env
    f(...)
  }
  RUnit::checkException(
    test.func(f=getAMR.obsolete, env=test.env,
              ramr.data, ramr.samples, ramr.method="beta", min.cpgs=5, merge.window=10000, qval.cutoff=1e-3, cores=2)
  )
}

---
title: "The ramr User's Guide"
author: "Oleksii Nikolaienko"
date: "`r format(Sys.time(), '%d %B, %Y')`"
abstract: |
  A comprehensive guide to using the ramr package for detection
  of rare aberrantly methylated regions (epimutations).
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{ramr}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  width = 100
)
options(width=100)
```

# Introduction

`ramr` is an R package for detection of low-frequency aberrant methylation events (epimutations) in large data sets obtained by methylation profiling using array or high-throughput methylation sequencing. In addition, package provides functions to visualize found aberrantly methylated regions (AMRs), to generate sets of all possible regions to be used as reference sets for enrichment analysis, and to generate biologically relevant test data sets for performance evaluation of AMR/DMR search algorithms.

### Current Features

-   Identification of aberrantly methylated regions (AMRs, i.e., epimutations)
-   AMR visualization
-   Generation of reference sets for third-party analyses (e.g., enrichment)
-   Generation of test data sets for performance evaluation of algorithms for search of differentially (DMR) or aberrantly (AMR) methylated regions

### Major improvements

##### v1.16 [BioC 3.21]

-   Major rewrite of `getAMR` and `simulateData` functions, which are now much faster (C/C++, OpenMP threads) and more robust (correctly deal with methylation sequencing data that often contains 0 and 1 values).
-   Old functions `getAMR` and `simulateData` as they were described in the `ramr` paper are now obsolete, but kept under different names (`getAMR.obsolete` and `simulateData.obsolete`, respectively) for consistency.
-   Cleaner and more robust AMR plotting.

# Reading data

`ramr` methods operate on objects of the class `GRanges`. The input object for AMR search must in addition contain metadata columns with sample beta values. A typical input object looks like this:

```         
GRanges object with 383788 ranges and 845 metadata columns:
             seqnames    ranges strand |         GSM1235534         GSM1235535         GSM1235536 ...
                <Rle> <IRanges>  <Rle> |          <numeric>          <numeric>          <numeric> ...
  cg13869341     chr1     15865      * |  0.801634776091808  0.846486905008704   0.86732154737116 ...
  cg24669183     chr1    534242      * |  0.834138820071765  0.861974610731835  0.832557979806823 ...
  cg15560884     chr1    710097      * |  0.711275180750356   0.70461945838556  0.699487225634589 ...
  cg01014490     chr1    714177      * | 0.0769098196182058 0.0569443780518647 0.0623154673389864 ...
  cg17505339     chr1    720865      * |  0.876413362222415  0.885593263385521  0.877944732153869 ...
         ...      ...       ...    ... .                ...                ...                ... ...
  cg05615487    chr22  51176407      * |   0.84904178467798  0.836538383875097   0.81568519870099 ...
  cg22122449    chr22  51176711      * |  0.882444486059592  0.870804215405886  0.859269224277308 ...
  cg08423507    chr22  51177982      * |  0.886406345093286  0.882430879852752  0.887241923657461 ...
  cg19565306    chr22  51222011      * | 0.0719084295670266 0.0845209871264646 0.0689074604483659 ...
  cg09226288    chr22  51225561      * |  0.724145303755024  0.696281176451351  0.711459675603635 ...
```

`ramr` package is supplied with a sample data, which was simulated using GSE51032 data set as described in the `ramr` reference paper. Sample data set `ramr.data` contains beta values for 10000 CpGs and 100 samples (`ramr.samples`), and carries 6 unique (`ramr.tp.unique`) and 15 non-unique (`ramr.tp.nonunique`) true positive AMRs containing at least 10 CpGs with their beta values increased/decreased by 0.5

```{r, fig.width=10, fig.height=4, out.width="100%", out.height="100%"}
library(GenomicRanges)
library(ggplot2)
library(ramr)
data(ramr)

head(ramr.samples)
ramr.data[1:10,ramr.samples[1:3]]
plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.unique[1])
plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.nonunique[c(1,6,11)])
```

The input (or template) object may be obtained using data from various sources. Here we provide two examples:

### Using data from NCBI GEO

The following code pulls (NB: very large) raw files from NCBI GEO database, performes normalization and creates `GRanges` object for further analysis using `ramr` (system requirements: 22GB of disk space, 64GB of RAM)

```         
library(minfi)
library(GEOquery)
library(GenomicRanges)
library(IlluminaHumanMethylation450kanno.ilmn12.hg19)

# destination for temporary files
dest.dir <- tempdir()

# downloading and unpacking raw IDAT files
suppl.files <- getGEOSuppFiles("GSE51032", baseDir=dest.dir, makeDirectory=FALSE, filter_regex="RAW")
untar(rownames(suppl.files), exdir=dest.dir, verbose=TRUE)
idat.files  <- list.files(dest.dir, pattern="idat.gz$", full.names=TRUE)
sapply(idat.files, gunzip, overwrite=TRUE)

# reading IDAT files
geo.idat <- read.metharray.exp(dest.dir)
colnames(geo.idat) <- gsub("(GSM\\d+).*", "\\1", colnames(geo.idat))

# processing raw data
genomic.ratio.set <- preprocessQuantile(geo.idat, mergeManifest=TRUE, fixOutliers=TRUE)

# creating the GRanges object with beta values
data.ranges <- granges(genomic.ratio.set)
data.betas  <- getBeta(genomic.ratio.set)
sample.ids  <- colnames(geo.idat)
mcols(data.ranges) <- data.betas

# data.ranges and sample.ids objects are now ready for AMR search using ramr
```

### Using Bismark cytosine report files

```         
library(methylKit)
library(GenomicRanges)

# file.list is a user-defined character vector with full file names of Bismark cytosine report files
file.list

# sample.ids is a user-defined character vector holding sample names
sample.ids

# methylation context string, defines if the reads covering both strands will be merged
context <- "CpG"

# fitting beta distribution (filtering using ramr.method "beta" or "wbeta") requires
# that most of the beta values are not equal to 0 or 1
min.beta <- 0.001
max.beta <- 0.999

# reading and uniting methylation values
meth.data.raw <- methRead(as.list(file.list), as.list(sample.ids), assembly="hg19", header=TRUE,
                          context=context, resolution="base", treatment=rep(0,length(sample.ids)),
                          pipeline="bismarkCytosineReport")
meth.data.utd <- unite(meth.data.raw, destrand=isTRUE(context=="CpG"))

# creating the GRanges object with beta values
data.ranges <- GRanges(meth.data.utd)
data.betas  <- percMethylation(meth.data.utd)/100
data.betas[data.betas<min.beta] <- min.beta
data.betas[data.betas>max.beta] <- max.beta
mcols(data.ranges) <- data.betas

# data.ranges and sample.ids objects are now ready for AMR search using ramr
```

# Simulating data

`ramr` provides methods to create sets of random AMRs and to generate biologically relevant methylation beta values using real data sets as templates. The following code provides an example, however it is recommended to use a real experimental data (e.g. GSE51032) to create a test data set for assessing the performance of `ramr` or other AMR/DMR search engines. The results of data simulation are fully reproducible when the same seed has been set (at a cost of serial random number generation).

```{r, fig.width=10, fig.height=6, out.width="100%", out.height="100%"}
# set the seed if reproducible results required
  set.seed(999)

# unique random AMRs
  amrs.unique <-
    simulateAMR(template.ranges=ramr.data, nsamples=25, regions.per.sample=2,
                min.cpgs=5, merge.window=1000, dbeta=0.2)

# non-unique AMRs outside of regions with unique AMRs
  amrs.nonunique <-
    simulateAMR(template.ranges=ramr.data, nsamples=4, exclude.ranges=amrs.unique,
                sample.names=sprintf("sample%02i", c(2, 4, 8, 16)),
                samples.per.region=2, min.cpgs=5, merge.window=1000)
  
# random noise outside of AMR regions
  noise <-
    simulateAMR(ramr.data, nsamples=25, regions.per.sample=20,
                exclude.ranges=c(amrs.unique, amrs.nonunique),
                min.cpgs=1, max.cpgs=1, merge.window=1, dbeta=0.5)

# "smooth" methylation data without AMRs (negative control)
  smooth.data <-
    simulateData(template.ranges=ramr.data, nsamples=25)
  
# methylation data with AMRs and noise
  noisy.data <-
    simulateData(template.ranges=ramr.data, nsamples=25,
                 amr.ranges=c(amrs.unique, amrs.nonunique, noise))
  
# that's how regions look like
  library(gridExtra)

  do.call("grid.arrange", c(plotAMR(data.ranges=noisy.data, amr.ranges=amrs.unique[1:4]), ncol=2))
  do.call("grid.arrange", c(plotAMR(data.ranges=noisy.data, amr.ranges=sort(amrs.nonunique)[1:8]), ncol=2))
  do.call("grid.arrange", c(plotAMR(data.ranges=noisy.data, amr.ranges=noise[1:4]), ncol=2))
  
# can we find them?
  system.time(
    found <- getAMR(
      data.ranges=noisy.data,
      compute="beta+binom", compute.estimate="amle", compute.weights="logInvDist",
      combine.min.cpgs=5, combine.threshold=1e-2, combine.window=1000
    )
  )
  
# all possible regions
  all.ranges <- getUniverse(noisy.data, min.cpgs=5, merge.window=1000)
  
# true positives
  tp <- sum(found %over% c(amrs.unique, amrs.nonunique))
  
# false positives
  fp <- sum(found %outside% c(amrs.unique, amrs.nonunique))

# true negatives
  tn <- length(all.ranges %outside% c(amrs.unique, amrs.nonunique))
  
# false negatives
  fn <- sum(c(amrs.unique, amrs.nonunique) %outside% found)
  
# accuracy, MCC
  acc <- (tp+tn) / (tp+tn+fp+fn)
  mcc <- (tp*tn - fp*fn) / (sqrt(tp+fp)*sqrt(tp+fn)*sqrt(tn+fp)*sqrt(tn+fn))
  setNames(c(tp, fp, tn, fn), c("TP", "FP", "TN", "FN"))
  setNames(c(acc, mcc), c("accuracy", "MCC"))
```

# AMR identification

This code shows how to do basic analysis with `ramr` using provided data files:

```{r, fig.width=10, fig.height=6, out.width="100%", out.height="100%"}
# identify AMRs
amrs <- getAMR(
  data.ranges=ramr.data, data.samples=ramr.samples, compute="beta+binom",
      combine.min.cpgs=5, combine.threshold=1e-2, combine.window=1000
)

# inspect
sort(amrs)

do.call("grid.arrange", c(plotAMR(data.ranges=ramr.data, amr.ranges=amrs[1:10]), ncol=2))
```

The results of parallel AMR search are fully reproducible (do not depend on the seed).

# AMR annotation and enrichment analysis

If necessary, AMRs can be annotated to known genomic elements using R library `annotatr` [^1] or tested for potential enrichment in epigenetic or other marks using R library `LOLA` [^2]

[^1]: Raymond G Cavalcante, Maureen A Sartor, annotatr: genomic regions in context, Bioinformatics, Volume 33, Issue 15, 01 August 2017, Pages 2381–2383, <https://doi.org/10.1093/bioinformatics/btx183>

[^2]: Nathan C. Sheffield, Christoph Bock, LOLA: enrichment analysis for genomic region sets and regulatory elements in R and Bioconductor, Bioinformatics, Volume 32, Issue 4, 15 February 2016, Pages 587–589, <https://doi.org/10.1093/bioinformatics/btv612>

```{r}
# annotating AMRs using R library annotatr
library(annotatr)
annotation.types <- c("hg19_cpg_inter", "hg19_cpg_islands", "hg19_cpg_shores",
                      "hg19_cpg_shelves", "hg19_genes_intergenic", "hg19_genes_promoters",
                      "hg19_genes_5UTRs", "hg19_genes_firstexons", "hg19_genes_3UTRs")
annotations <- build_annotations(genome='hg19', annotations=annotation.types)
amrs.annots <- annotate_regions(regions=amrs, annotations=annotations, ignore.strand=TRUE, quiet=FALSE)
summarize_annotations(annotated_regions=amrs.annots, quiet=FALSE)
```

```         
# generate the set of all possible genomic regions using sample data set and
# the same parameters as for AMR search
universe <- getUniverse(ramr.data, min.cpgs=5, merge.window=1000)

# enrichment analysis of AMRs using R library LOLA
library(LOLA)
# prepare the core database as described in vignettes
vignette("usingLOLACore")
# load the core database and perform the enrichment analysis
hg19.coredb <- loadRegionDB(system.file("LOLACore", "hg19", package="LOLA"))
runLOLA(amrs, universe, hg19.coredb, cores=1, redefineUserSets=TRUE)
```

# Other information

### Citing the `ramr` package

Oleksii Nikolaienko, Per Eystein Lønning, Stian Knappskog, *ramr*: an R/Bioconductor package for detection of rare aberrantly methylated regions, Bioinformatics, 2021;, btab586, <https://doi.org/10.1093/bioinformatics/btab586>

### The data underlying `ramr` manuscript

Replication Data for: "ramr: an R package for detection of rare aberrantly methylated regions, <https://doi.org/10.18710/ED8HSD>

### Session Info

```{r session}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getAMR.R
\name{getAMR}
\alias{getAMR}
\title{Search for aberrantly methylated regions}
\usage{
getAMR(
  data.ranges,
  data.samples = NULL,
  data.coverage = NULL,
  transform = c("identity", "linear"),
  exclude.range = NULL,
  compute = c("IQR", "beta+binom"),
  compute.estimate = c("mom", "amle", "nmle"),
  compute.weights = c("equal", "logInvDist", "sqrtInvDist", "invDist"),
  combine = c("threshold", "comb-p"),
  combine.threshold = ifelse(compute == "IQR", 5, 0.001),
  combine.window = 300,
  combine.min.cpgs = 7,
  combine.min.width = 1,
  combine.ignore.strand = FALSE,
  ncores = NULL,
  verbose = TRUE
)
}
\arguments{
\item{data.ranges}{A `GRanges` object with genomic locations and
corresponding beta values included as metadata.}

\item{data.samples}{A character vector with sample names (e.g., a subset of
metadata column names). If `NULL` (the default), then all samples (metadata
columns) are included in the analysis.}

\item{data.coverage}{An optional `data.frame` object with coverage data. If
provided, must be an all-integer `data.frame`, with the same dimensions
and column names as the `data.ranges` metadata columns.}

\item{transform}{A character scalar specifying if beta values should be
used as supplied ("identity", the default) or linearly transformed ("linear")
to force all \eqn{\{0;1\}} endpoint (extreme) values within open \eqn{(0,1)}
interval using the following formula: \deqn{x'=\frac{x(N-1)+0.5}{N}}
where \eqn{x} is the beta value before transformation, and \eqn{N} is the
number of samples. Such transformation is recommended only
if beta values contain \eqn{\{0;1\}} values \bold{and} coverage data is NOT
available. See \href{https://doi.org/10.1037/1082-989x.11.1.54}{doi: 10.1037/1082-989X.11.1.54}
and \href{https://stats.stackexchange.com/questions/31300/dealing-with-0-1-values-in-a-beta-regression}{Dealing with 0,1 values in a beta regression} for more details.}

\item{exclude.range}{A numeric vector of length two. Unless `NULL`
(the default), all `data.ranges` genomic locations with their median
methylation beta value within the `exclude.range` interval are filtered out.}

\item{compute}{A character scalar: when "IQR" (the
default), AMR search based on interquantile range is performed.
When "beta+binom" - search is based on fitting optionally weighted
beta distribution (with the possibility of estimating binomial probability
of \eqn{\{0;1\}} endpoint values). See Details section for explanation.}

\item{compute.estimate}{A character scalar for the method of parameter
estimation of beta distribution. The default ("mom") stands for the method
of moments based on the unbiased estimator of variance and includes
\eqn{\{0;1\}} endpoints in calculation of moments (mean, unbiased variance).
Other options are "amle" (approximation of maximum likelihood estimation)
and "nmle" (numeric maximum likelihood estimation) - both ignore
\eqn{\{0;1\}} endpoints in calculations. See Details section for explanation.}

\item{compute.weights}{A character scalar for the weights assigned to
individual observations (beta values) and used to compute weighted
means and variance as described in "Compute" section below. Four available
weighing schemes result in different sensitivity of outlier detection and
rate of false positive (FP) findings: "equal" (the default) is the least
sensitive and gives least number of FPs, while "invDist" is the most
sensitive but may result in a very high number of FPs especially when
`combine.threshold` is too high (1e-3 or higher).
"logInvDist" is recommended when one desires a balance between relatively
low type I error rate and higher
detection sensitivity for both unique and non-unique AMRs.

If "equal", all weights are equal to 1 (\eqn{w_i=1}).
Otherwise, weights of observations inversely depend on their distance from
the median (thus emphasizing outliers) and are calculated using the
following formulas:
\deqn{\text{"logInvDist": } w_i = \log{\frac{1}{|M-x_i|+\epsilon}}}
\deqn{\text{"sqrtInvDist": } w_i = \sqrt{\frac{1}{|M-x_i|+\epsilon}}}
\deqn{\text{"invDist": } w_i = \frac{1}{|M-x_i|+\epsilon}}
where \eqn{x_i} is a beta value for i-th sample, \eqn{M} is a median of
all beta values at this genomic location, and \eqn{\epsilon} is a very
small number (= FLT_EPSILON \eqn{\approx} 1.192093e-07).}

\item{combine}{A character scalar for the method used to combine individual
outlier genomic positions into genomic intervals (ranges). When "threshold"
(the default) is used, simple thresholding is applied.
More details are given in the "Combine" subsection below.}

\item{combine.threshold}{A numeric scalar setting the threshold for an
outlier value. When `compute=="IQR"`, methylation beta values differing
from the median value by at least `combine.threshold` interquartile ranges
are considered to be outliers (the default: 5). When `compute=="beta+binom"`,
all probability values not higher than `combine.threshold` are considered
to be outliers (the default: 0.001).}

\item{combine.window}{A positive integer. All significant (survived the
filtering stage) `data.ranges` genomic locations within this distance will be
merged to create AMRs (the default: 300).}

\item{combine.min.cpgs}{A single integer >= 1. All AMRs containing less than
`combine.min.cpgs` significant genomic locations are filtered out (the
default: 7).}

\item{combine.min.width}{A single integer >= 1 (the default).
Only AMRs with the width of at least `combine.min.width` are returned.}

\item{combine.ignore.strand}{A boolean scalar to ignore strand information
in the input `data.ranges` and when outlier genomic positions are combined
into genomic intervals (the default: FALSE).}

\item{ncores}{A single integer >= 1. Number of OpenMP threads for parallel
computation (the default: half of the available cores). Results of parallel
processing are fully reproducible.}

\item{verbose}{Boolean to report progress and timings (default: TRUE).}
}
\value{
The output is a `GRanges` object that contains all the aberrantly
methylated regions (AMRs / epimutations) for all `data.samples` samples in
`data.ranges` object. The following metadata columns may be present:
\itemize{
  \item `revmap` -- integer list of significant CpGs (`data.ranges` genomic
  locations) that are included in this AMR region
  \item `ncpg` -- number of significant CpGs within this AMR region
  \item `sample` -- contains an identifier of a sample to which
  corresponding AMR belongs
  \item `dbeta` -- average deviation of beta values for significant CpGs from
  their corresponding median values
  \item `pval` -- geometric mean of p-values for significant CpGs
  \item `xiqr` -- average IQR-normalised deviation of beta values for
  significant CpGs from their corresponding median values
}
}
\description{
`getAMR` returns a `GRanges` object with aberrantly methylated
regions (AMRs / epimutations) for all samples in a data set.
}
\details{
In the provided data set, `getAMR` finds stretches of outlier beta values
to identify rare long-range methylation
aberrations (epimutations) in one or several samples. As a rule, methods for
differential methylation analysis rely on between-group comparisons ---
`getAMR` performs this comparison within-group, which is not only faster,
but also more sensitive. The logic of computations is described below.

\subsection{Compute}{
This section describes computations that are performed in order to identify
individual outlier beta values --- but
\bold{before values are deemed as outliers}.
At the moment, the two supported methods are:

\describe{
  \item{"IQR"}{
    When `compute=="IQR"`, for every genomic location (CpG) in
    `data.ranges` the IQR-normalized deviation from the median value is
    calculated using the following formula:
    \deqn{xIQR_i=\frac{x_i-M}{IQR}}
    where \eqn{x_i} is a beta value for i-th sample,
    \eqn{M} and \eqn{IQR} are a median and an interquartile range
    of all beta values at this genomic location, respectively.
  }
  \item{"beta+binom"}{
    When `compute=="beta+binom"`, for every genomic location (CpG),
    `getAMR` will estimate the probability of each beta value to occur.
    For all beta values inside the open \eqn{(0,1)} interval, beta
    distribution is used. For all \eqn{\{0;1\}} endpoint (extreme) values
    where beta distribution is not defined, binomial probability is
    calculated using coverage data (supplied using `data.coverage`
    parameter).

    Alpha \eqn{{\alpha}} and beta \eqn{{\beta}} parameters of beta
    distribution can be estimated using one of the following methods:

    \enumerate{
      \item{
        Method of moments (`compute.estimate="mom"`) based on
        (both optionally weighted) mean and unbiased variance
        \deqn{\text{sample mean} = \bar{x} = \frac{ \sum\limits_{i=1}^n w_i x_i}{\sum\limits_{i=1}^n w_i}}
        \deqn{\text{unbiased variance} =\bar{v} = \frac {\sum\limits_{i=1}^N w_i (x_i - \bar{x})^2} {\sum_{i=1}^N w_i - (\sum_{i=1}^N w_i^2 / \sum_{i=1}^N w_i)} }
        where \eqn{x_i} and \eqn{w_i} are a beta value and its reliability
        weight for i-th sample.
        \deqn{\hat{\alpha} = \bar{x} \left(\frac{\bar{x} (1 - \bar{x})}{\bar{v}} - 1 \right)}
        \deqn{\hat{\beta} = (1-\bar{x}) \left(\frac{\bar{x} (1 - \bar{x})}{\bar{v}} - 1 \right)}
        Note: all beta values from the closed \eqn{[0,1]} interval are used
        for calculation of arithmetic mean value.
        For more details on used formulas, visit
        \href{https://en.wikipedia.org/wiki/Weighted_arithmetic_mean#Mathematical_definition}{Weighted arithmetic mean},
        \href{https://en.wikipedia.org/wiki/Weighted_arithmetic_mean#Reliability_weights}{Weighted variance with reliability weights},
        and \href{https://en.wikipedia.org/wiki/Beta_distribution#Method_of_moments}{Method of moments for beta distribution}
      }
      \item{
        Approximate maximum likelihood (`compute.estimate="amle"`) based on
        (both optionally weighted) geometric means of \eqn{x} and \eqn{(1-x)}
        \deqn{ \hat{G}_x = \left(\prod_{i=1}^n x_i^{w_i}\right)^{1 / \sum_{i=1}^n w_i} }
        \deqn{ \hat{G}_{(1-x)} = \left(\prod_{i=1}^n {(1-x_i)}^{w_i}\right)^{1 / \sum_{i=1}^n w_i} }
        where \eqn{x_i} and \eqn{w_i} are a beta value and its reliability
        weight for i-th sample.
        \deqn{ \hat{\alpha}\approx \tfrac{1}{2} + \frac{\hat{G}_{x}}{2(1-\hat{G}_x-\hat{G}_{(1-x)})} }
        \deqn{ \hat{\beta}\approx \tfrac{1}{2} + \frac{\hat{G}_{(1-x)}}{2(1-\hat{G}_x-\hat{G}_{(1-x)})} }
        Note: only beta values from the open \eqn{(0,1)} interval are used
        for calculation of geometric means.
        For more details, visit
        \href{https://en.wikipedia.org/wiki/Weighted_geometric_mean}{Weighted geometric mean},
        and \href{https://en.wikipedia.org/wiki/Beta_distribution#Two_unknown_parameters_2}{Maximum likelihood for beta distribution}
      }
      \item{
        And a numerical maximum likelihood (`compute.estimate="nmle"`) which
        is yet to be implemented.
      }
    }

    After estimating parameters of beta distribution,
    probabilities of observed beta values from the open \eqn{(0,1)} interval
    are computed using regularized incomplete beta function
    \eqn{I_x(\alpha, \beta)}. For more details, visit
    \href{https://en.wikipedia.org/wiki/Beta_distribution#Cumulative_distribution_function}{Cumulative distribution function for beta distribution}.

    Probabilities of \eqn{\{0;1\}} endpoint values are computed using
    mean value (either arithmetic for `compute.estimate="mom"` or geometric
    for `compute.estimate="*mle"`) using the following formulas:
    \deqn{{p^0}_i=(1-\bar{x})^k}
    \deqn{{p^1}_i=\bar{x}^k}
    where \eqn{{p^0}_i} and \eqn{{p^1}_i} are probabilities of
    observing 0 or 1 for i-th sample, respectively,
    \eqn{\bar{x}} is a mean of all beta values for this genomic
    position, and \eqn{k} is a sequencing coverage of this genomic
    position for i-th sample.
  }
}


}

\subsection{Combine}{
This section describes how individual beta values are deemed as outliers
and how these outliers are combined into extended genomic regions
(aberrantly methylated regions, AMRs, or epimutations).
The only method supported at the moment is thresholding as
described below.

\describe{
  \item{"threshold"}{
    This method applies a fixed threshold (specified using
    `combine.threshold` parameter) to all `xIQR` or probability
    values computed at the previous step. All observed beta values that
    are passing this threshold (above or equal to the threshold for `xIQR`;
    below or equal in case of probability values) are considered to be
    outliers and therefore retained.

    Next, for all outlier beta values per sample, corresponding genomic
    positions are merged into genomic intervals using the window of
    `combine.window` and keeping the strand information unless
    `combine.ignore.strand` is TRUE.
  }
  \item{"comb-p"}{
    This method of combining outliers into genomic ranges is yet to be
    implemented.
  }
}

Resulting genomic intervals are then filtered:
only the regions containing at least `combine.min.cpgs`
outliers and which are at leas as wide as `combine.min.width` are
reported back.

As a final step, the following average values are computed for every
aberrantly methylated region:
\enumerate{
  \item{
    arithmetic mean of distances of all outlier beta values to
    a median beta value (`dbeta`)
  }
  \item{
    if `compute=="IQR"`, arithmetic mean of xIQR values of all outlier
    genomic position (`xiqr`) OR
  }
  \item{
    if `compute=="beta+binom"`, geometric mean of probability values
    of all outlier genomic position (`pval`)
  }
}

}
}
\note{
NA values within metadata columns of `data.ranges` are silently dropped
in all computations.
}
\examples{
  data(ramr)
  getAMR(data.ranges=ramr.data, data.samples=ramr.samples,
         compute="beta+binom", compute.estimate="amle",
         combine.min.cpgs=5, combine.window=1000, combine.threshold=1e-3)
}
\seealso{
\code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
for info on enrichment analysis, \code{\link{simulateAMR}} and
\code{\link{simulateData}} for the generation of simulated test data sets,
and `ramr` vignettes for the description of usage and sample data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ramr-data.R
\docType{data}
\name{ramr.data}
\alias{ramr.data}
\alias{ramr.samples}
\alias{ramr.tp.unique}
\alias{ramr.tp.nonunique}
\title{Simulated Illumina HumanMethylation 450k data set with 3000 CpGs and 100
samples}
\format{
Objects of class \code{"GRanges"} (\code{"ramr.data, ramr.tp.unique,
ramr.tp.nonunique"}) and \code{"character"} (\code{"ramr.samples"}).
}
\usage{
data(ramr)
}
\description{
Data was simulated using GSE51032 data set as described in the reference.
Current data set (\code{"ramr.data"}) contains beta values for 10000 CpGs
and 100 samples (\code{"ramr.samples"}), and carries 6 unique
(\code{"ramr.tp.unique"}) and 15 non-unique (\code{"ramr.tp.nonunique"})
true positive AMRs containing at least 10 CpGs with their beta values
increased/decreased by 0.5.
}
\examples{
  data(ramr)
  amrs <- getAMR(
    data.ranges=ramr.data, compute="IQR",
    combine.min.cpgs=5, combine.window=1000, combine.threshold=5
  )
  plotAMR(data.ranges=ramr.data, amr.ranges=amrs[1])
  plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.nonunique[4],
          highlight=c("sample7","sample8","sample9"))

}
\references{
Nikolaienko et al., 2020
(\href{https://doi.org/10.1101/2020.12.01.403501}{bioRxiv})
}
\keyword{data}
\keyword{sets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getAMR.obsolete.R
\name{getAMR.obsolete}
\alias{getAMR.obsolete}
\title{[OBSOLETE] Search for aberrantly methylated regions}
\usage{
getAMR.obsolete(
  data.ranges,
  data.samples = NULL,
  ramr.method = c("IQR", "beta", "wbeta", "beinf"),
  iqr.cutoff = 5,
  pval.cutoff = 0.05,
  qval.cutoff = NULL,
  merge.window = 300,
  min.cpgs = 7,
  min.width = 1,
  exclude.range = NULL,
  cores = max(1, parallel::detectCores() - 1),
  verbose = TRUE,
  ...
)
}
\arguments{
\item{data.ranges}{A `GRanges` object with genomic locations and
corresponding beta values included as metadata.}

\item{data.samples}{A character vector with sample names (a subset of
metadata column names). If `NULL` (the default), then all samples (metadata
columns) are included in the analysis.}

\item{ramr.method}{A character scalar: when ramr.method is "IQR" (the
default), the filtering based on interquantile range is used (`iqr.cutoff`
value is then used as a threshold). When "beta", "wbeta" or "beinf" -
filtering based on fitting non-weighted (`EnvStats::ebeta`), weighted
(`ExtDist::eBeta`) or zero-and-one inflated (`gamlss.dist::BEINF`)
beta distributions, respectively, is used, and `pval.cutoff` or `qval.cutoff`
(if not `NULL`) is used as a threshold. For "wbeta", weights directly
correlate with bin contents (number of values per bin) and inversly - with
the distances from the median value, thus narrowing the estimated
distribution and emphasizing outliers.}

\item{iqr.cutoff}{A single integer >= 1. Methylation beta values differing
from the median value by more than `iqr.cutoff` interquartile ranges are
considered to be significant (the default: 5).}

\item{pval.cutoff}{A numeric scalar (the default: 5e-2). Bonferroni
correction of `pval.cutoff` by the length of the `data.samples` object is
used to calculate `qval.cutoff` if the latter is `NULL`.}

\item{qval.cutoff}{A numeric scalar. Used as a threshold for filtering based
on fitting non-weighted or weighted beta distributions: all p-values lower
than `qval.cutoff` are considered to be significant. If `NULL` (the default),
it is calculated using `pval.cutoff`}

\item{merge.window}{A positive integer. All significant (survived the
filtering stage) `data.ranges` genomic locations within this distance will be
merged to create AMRs (the default: 300).}

\item{min.cpgs}{A single integer >= 1. All AMRs containing less than
`min.cpgs` significant genomic locations are filtered out (the default: 7).}

\item{min.width}{A single integer >= 1 (the default). Only AMRs with the
width of at least `min.width` are returned.}

\item{exclude.range}{A numeric vector of length two. If not `NULL` (the
default), all `data.ranges` genomic locations with their median methylation
beta value within the `exclude.range` interval are filtered out.}

\item{cores}{A single integer >= 1. Number of processes for parallel
computation (the default: all but one cores). Results of parallel processing
are fully reproducible when the same seed is used (thanks to doRNG).}

\item{verbose}{boolean to report progress and timings (default: TRUE).}

\item{...}{Further arguments to be passed to `EnvStats::ebeta` or
`ExtDist::eBeta` functions.}
}
\value{
The output is a `GRanges` object that contains all the aberrantly
methylated regions (AMRs) for all `data.samples` samples in `data.ranges`
object. The following metadata columns may be present:
\itemize{
  \item `revmap` -- integer list of significant CpGs (`data.ranges` genomic
  locations) that are included in this AMR region
  \item `ncpg` -- number of significant CpGs within this AMR region
  \item `sample` -- contains an identifier of a sample to which
  corresponding AMR belongs
  \item `dbeta` -- average deviation of beta values for significant CpGs from
  their corresponding median values
  \item `pval` -- geometric mean of p-values for significant CpGs
  \item `xiqr` -- average IQR-normalised deviation of beta values for
  significant CpGs from their corresponding median values
}
}
\description{
This function is fully functional but obsolete. It will remain a part of the
package for consistency, as it was used in `ramr` publication
(\doi{10.1093/bioinformatics/btab586}). Please use faster and more capable
\code{\link{getAMR}} instead.

`getAMR.obsolete` returns a `GRanges` object with all the aberrantly
methylated regions (AMRs) for all samples in a data set.
}
\details{
In the provided data set, `getAMR.obsolete` compares methylation beta values
of each sample with other samples to identify rare long-range methylation
aberrations (epimutations).
For `ramr.method=="IQR"`: for every genomic location (CpG) in
`data.ranges` the IQR-normalized deviation from the median value is
calculated, and all CpGs with such normalized deviation not smaller than the
`iqr.cutoff` are retained. For
`ramr.method %in% c("beta", "wbeta", "beinf")`: parameters of beta
distribution are estimated by means of `EnvStats::ebeta` (beta distribution),
`ExtDist::eBeta` (weighted beta destribution), or `gamlss.dist::BEINF` (zero
and one inflated beta distribution) functions, respectively. These
parameters are then used to calculate the probability values, followed by the
filtering when all CpGs with p-values not greater than `qval.cutoff` are
retained. Another filtering is then performed to exclude all CpGs within
`exclude.range`. Next, the retained (significant) CpGs are merged within
the window of `merge.window`, and final filtering is applied to AMR genomic
ranges (by `min.cpgs` and `min.width`).
}
\examples{
  data(ramr)
  getAMR.obsolete(ramr.data, ramr.samples, ramr.method="beta",
                  min.cpgs=5, merge.window=1000, qval.cutoff=1e-3, cores=2)
}
\seealso{
\code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
for info on enrichment analysis, \code{\link{simulateAMR}} and
\code{\link{simulateData}} for the generation of simulated test data sets,
and `ramr` vignettes for the description of usage and sample data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAMR.R
\name{plotAMR}
\alias{plotAMR}
\title{Plot aberrantly methylated regions}
\usage{
plotAMR(
  data.ranges,
  amr.ranges,
  data.samples = NULL,
  window = 300,
  ignore.strand = FALSE,
  highlight = NULL,
  title = NULL,
  labs = c("genomic position", "beta value"),
  transform = c("identity", "log1p", "log10"),
  limits = NULL,
  breaks = NULL,
  verbose = TRUE
)
}
\arguments{
\item{data.ranges}{A `GRanges` object with genomic locations and
corresponding beta values included as metadata.}

\item{amr.ranges}{An output of `getAMR` - a `GRanges` object that contain
aberrantly methylated regions (AMRs).}

\item{data.samples}{A character vector with sample names (a subset of
metadata column names) to be included in the plot. If `NULL` (the default),
then all samples (metadata columns) are included.}

\item{window}{An optional integer constant to expand genomic ranges of the
`amr.ranges` object (the default: 300).}

\item{ignore.strand}{Boolean to ignore strand of AMR region. Default: FALSE.}

\item{highlight}{An optional list of samples to highlight. If NULL (the
default), will contain sample IDs from the `sample` metadata column of
`amr.ranges` object.}

\item{title}{An optional title for the plot. If NULL (the default), plot
title is set to a genomic location of particular AMR.}

\item{labs}{Optional axis labels for the plot. Default: c("genomic position",
"beta value").}

\item{transform}{Optional transformation of y-axis. Default: "identity"
(no transformation).}

\item{limits}{Optional limits of y-axis. When default (NULL), limits
are c(NA,1) for `transform=="log10"` and c(0,1) otherwise.}

\item{breaks}{Optional breaks of y-axis. When default (NULL), breaks
are `10**(seq(from=-5, to=0, length.out=6))` for `transform=="log10"` and
`seq(from=0, to=1, length.out=6)` otherwise.}

\item{verbose}{Boolean to report progress and timings (default: TRUE).}
}
\value{
The output is a list of `ggplot` objects.
}
\description{
`plotAMR` uses `ggplot2` to visualize aberrantly methylated regions (AMRs)
at particular genomic locations.
}
\details{
For every non-overlapping genomic location from `amr.ranges` object,
`plotAMR` plots and outputs a line graph of methylation beta values taken
from `data.ranges` for all samples from `data.samples`. Samples bearing
significantly different methylation profiles ('sample' column of
`amr.ranges` object) are highlighted.
}
\examples{
  data(ramr)
  plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.unique[1])
  library(gridExtra)
  do.call("grid.arrange",
          c(plotAMR(data.ranges=ramr.data, amr.ranges=ramr.tp.nonunique), ncol=2))
}
\seealso{
\code{\link{getAMR}} for identification of AMRs,
\code{\link{getUniverse}} for info on enrichment analysis,
\code{\link{simulateAMR}} and \code{\link{simulateData}} for the generation
of simulated test data sets, and `ramr` vignettes for the description of
usage and sample data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getUniverse.R
\name{getUniverse}
\alias{getUniverse}
\title{Merges, filters and outputs all genomic regions of a given `GRanges` object}
\usage{
getUniverse(data.ranges, merge.window = 300, min.cpgs = 7, min.width = 1)
}
\arguments{
\item{data.ranges}{A `GRanges` object with genomic locations and
corresponding beta values included as metadata.}

\item{merge.window}{A single integer >= 1. All `data.ranges` genomic
locations within this distance will be merged (the default: 300).}

\item{min.cpgs}{A single integer >= 1. All genomic regions containing less
than `min.cpgs` genomic locations are filtered out (the default: 7).}

\item{min.width}{A single integer >= 1 (the default). Only regions with the
width of at least `min.width` are returned.}
}
\value{
The output is a `GRanges` object that contain all the genomic regions
in `data.ranges` object (in other words, all potential AMRs).
}
\description{
`getUniverse` returns a `GRanges` object with all the genomic regions in a
data set, that can be used for AMR enrichment analysis
}
\details{
In the provided data set `getUniverse` merges and outputs all the genomic
regions that satisfy filtering criteria, thus creating a `GRanges` object to
be used as a reference set of genomic regions for AMR enrichment analysis.
}
\examples{
  data(ramr)
  universe <- getUniverse(ramr.data, min.cpgs=5, merge.window=1000)
\donttest{
  # identify AMRs
  amrs <- getAMR(
    data.ranges=ramr.data, compute="beta+binom",
    combine.min.cpgs=5, combine.window=1000, combine.threshold=1e-3
  )

  # AMR enrichment analysis using LOLA
  library(LOLA)
  # download LOLA region databases from http://databio.org/regiondb
  hg19.extdb.file <- system.file("LOLAExt", "hg19", package="LOLA")
  if (file.exists(hg19.extdb.file)) {
    hg19.extdb  <- loadRegionDB(hg19.extdb.file)
    runLOLA(amrs, universe, hg19.extdb, cores=1, redefineUserSets=TRUE)
  }
}
}
\seealso{
\code{\link{getAMR}} for identification of AMRs,
\code{\link{plotAMR}} for plotting AMRs, \code{\link{simulateAMR}} and
\code{\link{simulateData}} for the generation of simulated test data sets,
and `ramr` vignettes for the description of usage and sample data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulateData.R
\name{simulateData}
\alias{simulateData}
\title{Template-based simulation of methylation data sets}
\usage{
simulateData(
  template.ranges,
  nsamples,
  amr.ranges = NULL,
  sample.names = NULL,
  compute = "beta+binom",
  compute.estimate = c("mom", "amle", "nmle"),
  compute.weights = c("equal", "logInvDist", "sqrtInvDist", "invDist"),
  ncores = NULL,
  verbose = TRUE
)
}
\arguments{
\item{template.ranges}{A `GRanges` object with genomic locations and
corresponding methylation beta values included as metadata (the same object
must be supplied to this and to the `simulateAMR` functions).}

\item{nsamples}{A single integer >= 1 indicating the number of samples to
generate.}

\item{amr.ranges}{A `GRanges` object with genomic locations of methylation
aberrations (epimutations). If `NULL` (the default), no aberrations is
introduced, and function will return "smoothed" data set. If supplied,
`GRanges` object must contain the following metadata columns:
\itemize{
  \item `revmap` -- integer list of `template.ranges` genomic locations that
  are included in this AMR region
  \item `sample` -- an identifier of a sample to which corresponding AMR
  belongs. Must be among the supplied or auto generated `sample.names`
  \item `dbeta` -- absolute deviation to be introduced. Must be numeric
  within the closed interval [0,1] or NA. When NA - the resulting beta value
  for the corresponding genomic position will also be NA
}
Such an object can be obtained using \code{\link{simulateAMR}} method or
manually.}

\item{sample.names}{A character vector with sample names. If `NULL` (the
default), sample names will be auto generated. When specified, the length
of the `sample.names` vector must be equal to the value of `nsamples`.}

\item{compute}{A single string for the distribution to fit to the data.
Currently accepts "beta+binom" (the default) only, which stands for
endpoint-inflated beta distribution. See Details section
and \code{\link{getAMR}} method description for additional explanations.}

\item{compute.estimate}{A single string for the method of parameter
estimation of beta distribution. The default ("mom") stands for the method
of moments based on the unbiased estimator of variance and includes \{0;1\}
endpoints in calculation of moments (mean, unbiased variance).
Other options are "amle" (approximation of maximum likelihood estimation)
and "nmle" (numeric maximum likelihood estimation) - both ignore \{0;1\}
endpoints in calculations. More details on these methods are given in
\code{\link{getAMR}} method description.}

\item{compute.weights}{A single string for the method to compute optional
sample weights that are used during estimation of beta distribution
parameters. If default ("equal"), all weights are equal. Otherwise, weight of
a value equals to a natural logarithm of inverse absolute distance of this
value to the sample median ("logInvDist"), a square root of inverse absolute
distance of this value to the sample median ("sqrtInvDist"), or an inverse
absolute distance of this value to the sample median ("invDist"). Using
weighted parameter estimation allows to increase sensitivity of outlier
detection. More details on weighted parameter estimation are given in
\code{\link{getAMR}} method description.}

\item{ncores}{A single integer >= 1 for the number of OpenMP threads for
parallel computation. By default (NULL), function will use half of available
cores. When the same random seed is set, results of this function are always
identical (reproducible), even when more than one core is used (at a cost
of serial random number generation).}

\item{verbose}{boolean to report progress and timings (default: TRUE).}
}
\value{
The output is a `GRanges` object with genomic ranges that are equal
to the genomic ranges of the provided template and metadata columns
containing generated methylation beta values for `nsamples` samples. If
`amr.ranges` object was supplied, then randomly generated beta values will be
modified accordingly.
}
\description{
`simulateData` generates aberration-free methylation data using an
experimental data set as a template, and further introduces methylation
aberrations if `GRanges` object containing a set of aberrantly methylated
regions was provided. The output can be used to evaluate performance
of algorithms for search of differentially (DMR) or aberrantly (AMR)
methylated regions.
}
\details{
For every genomic location in the template data set (`GRanges` object with
genomic locations and corresponding methylation beta values included as
metadata) `simulateData` does the following:
\itemize{
  \item estimates parameters of beta distribution
  \item in the same input, calculates frequencies of zero and one values
  (endpoints; whenever present)
  \item uses estimated parameters of beta distribution and probabilities
  (observed frequencies) of \{0;1\} values to generate `nsamples` random
  values by means of `stats::rbeta` function (for beta values) and/or
  `stats::rbinom` function (for \{0;1\} endpoint values, according to their
  frequencies and therefore probabilities).
}
This results in "smoothed" data set that has biologically relevant
distribution of methylation values at every genomic location,
but does not contain methylation
aberrations. If the `amr.ranges` parameter points to a `GRanges` object with
aberrations, every AMR is then introduced into the "smoothed" data set as
following: if mean methylation beta value for AMR region across all samples
in the "smoothed" data set is above (below) 0.5 then all beta values for the
sample defined by the `sample` metadata column are decreased (increased) by
the absolute value specified in the `dbeta` metadata column. Resulting
data sets with (or without) AMR together with the `amr.ranges` set of true
positive aberrations can be used as test data set to evaluate performance
of algorithms for search of differentially (DMR) or aberrantly (AMR)
methylated regions.
}
\note{
NA values within metadata columns of `template.ranges` are silently dropped
in all computations. NA values will also not appear in the result of
this function, unless parameters of beta distribution and/or probabilities
of zeros or ones cannot be estimated (e.g., due to too many NA values in
`template.ranges` metadata).
}
\examples{
  data(ramr)
  set.seed(1)
  amrs <-
    simulateAMR(ramr.data, nsamples=10, regions.per.sample=3,
                samples.per.region=1, min.cpgs=5, merge.window=1000)
  noise <-
    simulateAMR(ramr.data, nsamples=10, regions.per.sample=20,
                exclude.ranges=amrs, min.cpgs=1, max.cpgs=1, merge.window=1)
  noisy.data <-
    simulateData(template.ranges=ramr.data, nsamples=10, amr.ranges=c(amrs,noise))
  plotAMR(data.ranges=noisy.data, amr.ranges=amrs[1])
}
\seealso{
\code{\link{simulateAMR}} for the generation of random methylation
aberrations, \code{\link{getAMR}} for identification of AMRs,
\code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
for info on enrichment analysis, and `ramr` vignettes for the description of
usage and sample data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulateData.obsolete.R
\name{simulateData.obsolete}
\alias{simulateData.obsolete}
\title{[OBSOLETE] Template-based simulation of methylation data sets}
\usage{
simulateData.obsolete(
  template.ranges,
  nsamples,
  amr.ranges = NULL,
  sample.names = NULL,
  min.beta = 0.001,
  max.beta = 0.999,
  cores = max(1, parallel::detectCores() - 1),
  verbose = TRUE
)
}
\arguments{
\item{template.ranges}{A `GRanges` object with genomic locations and
corresponding beta values included as metadata (same object
must be supplied to this and to the `simulateAMR` functions).}

\item{nsamples}{A single integer >= 1 indicating the number of samples to
generate.}

\item{amr.ranges}{A `GRanges` object with genomic locations of (rare)
methylation aberrations. If `NULL` (the default), no aberrations is
introduced, and function will return "smoothed" data set. If supplied,
`GRanges` object must contain the following metadata columns:
\itemize{
  \item `revmap` -- integer list of `template.ranges` genomic locations that
  are included in this AMR region
  \item `sample` -- an identifier of a sample to which corresponding AMR
  belongs. Must be among the supplied or auto generated `sample.names`
  \item `dbeta` -- absolute deviation to be introduced. Must be numeric
  within the range c(0,1) or NA. When NA - the resulting beta value for
  the corresponding genomic position will also be NA
}
Such an object can be obtained using \code{\link{simulateAMR}} method or
manually.}

\item{sample.names}{A character vector with sample names. If `NULL` (the
default), sample names will be computed as
`paste0("sample", seq_len(nsamples))`. When specified, the length of the
`sample.names` vector must be equal to the value of `nsamples`.}

\item{min.beta}{A single numeric within the range c(0,1). All beta values
in the generated data set below this value will be assigned this value.
The default: 0.001.}

\item{max.beta}{A single numeric within the range c(0,1). All beta values
in the generated data set above this value will be assigned this value.
The default: 0.999.}

\item{cores}{A single integer >= 1. Number of processes for parallel
computation (the default: all but one cores). Results of parallel processing
are fully reproducible when the same seed is used (thanks to doRNG).}

\item{verbose}{boolean to report progress and timings (default: TRUE).}
}
\value{
The output is a `GRanges` object with genomic ranges that are equal
to the genomic ranges of the provided template and metadata columns
containing generated methylation beta values for `nsamples` samples. If
`amr.ranges` object was supplied, then randomly generated beta values will be
modified accordingly.
}
\description{
This function is fully functional but obsolete. It will remain a part of the
package for consistency, as it was used in `ramr` publication
(\doi{10.1093/bioinformatics/btab586}). Please use faster and more capable
\code{\link{simulateData}} instead.

`simulateData.obsolete` generates aberration-free methylation data using an
experimental data set as a template, and further introduces methylation
aberrations if `GRanges` object containing a set of aberrantly methylated
regions was provided. The output can be used to evaluate performance
of algorithms for search of differentially (DMR) or aberrantly (AMR)
methylated regions.
}
\details{
For every genomic location in the template data set (`GRanges` object with
genomic locations and corresponding beta values included as metadata)
`simulateData.obsolete` estimates the parameters of beta distribution by
means of
`EnvStats::ebeta` function, and then uses estimated parameters to generate
`nsamples` random beta values by means of `stats::rbeta` function. This
results in "smoothed" data set that has biologically relevant distribution
of beta values at every genomic location, but does not contain methylation
aberrations. If the `amr.ranges` parameter points to a `GRanges` object with
aberrations, every AMR is then introduced into the "smoothed" data set as
following: if mean methylation beta value for AMR region across all samples
in the "smoothed" data set is above (below) 0.5 then all beta values for the
sample defined by the `sample` metadata column are decreased (increased) by
the absolute value specified in the `dbeta` metadata column. Resulting
data sets with (or without) AMR together with the `amr.ranges` set of true
positive aberrations can be used as test data set to evaluate performance
of algorithms for search of differentially (DMR) or aberrantly (AMR)
methylated regions.
}
\examples{
  data(ramr)
  amrs <-
    simulateAMR(ramr.data, nsamples=10, regions.per.sample=3,
                samples.per.region=1, min.cpgs=5, merge.window=1000)
  noise <-
    simulateAMR(ramr.data, nsamples=10, regions.per.sample=20,
                exclude.ranges=amrs, min.cpgs=1, max.cpgs=1, merge.window=1)
  noisy.data <-
    simulateData.obsolete(ramr.data, nsamples=10, amr.ranges=c(amrs,noise),
                          cores=2)
  plotAMR(noisy.data, amr.ranges=amrs[1])
}
\seealso{
\code{\link{simulateAMR}} for the generation of random methylation
aberrations, \code{\link{getAMR}} for identification of AMRs,
\code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
for info on enrichment analysis, and `ramr` vignettes for the description of
usage and sample data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulateAMR.R
\name{simulateAMR}
\alias{simulateAMR}
\title{Simulate a set of aberrantly methylated regions}
\usage{
simulateAMR(
  template.ranges,
  nsamples,
  exclude.ranges = NULL,
  regions.per.sample = 1,
  samples.per.region = 1,
  sample.names = NULL,
  merge.window = 300,
  min.cpgs = 7,
  max.cpgs = Inf,
  min.width = 1,
  dbeta = 0.25
)
}
\arguments{
\item{template.ranges}{A `GRanges` object with genomic locations (same object
must be supplied to this and to the `simulateData` functions).}

\item{nsamples}{A single integer >= 1 indicating the number of samples to
which AMRs will be assigned.}

\item{exclude.ranges}{A `GRanges` object with genomic locations. None of the
simulated AMRs in the output will overlap with any of regions from
`exclude.ranges`. If `NULL` (the default), AMRs are not restricted by their
genomic location.}

\item{regions.per.sample}{A single integer >= 1 (the default). Number of AMRs
to be assigned to every sample. Message is shown and the `regions.per.sample`
value is limited to `maxnAMR %/% nsamples` if it is greater than this number
(where `maxnAMR` is the maximum number of potential AMRs for the
`template.ranges`).}

\item{samples.per.region}{A single integer >= 1 (the default). Number of
samples to which the same AMR will be assigned. Message is shown and the
`samples.per.region` value is limited to `nsamples` if the former is greater
than the latter.}

\item{sample.names}{A character vector with sample names. If `NULL` (the
default), sample names will be computed as
`paste0("sample", seq_len(nsamples))`. When specified, the length of the
`sample.names` vector must not be smaller than the value of `nsamples`.}

\item{merge.window}{A positive integer. All `template.ranges` genomic
locations within this distance will be merged to create a list of potential
AMRs (which will be later filtered from regions overlapping with any regions
from the `exclude.ranges`).}

\item{min.cpgs}{A single integer >= 1. All AMRs containing less than
`min.cpgs` genomic locations are filtered out. The default: 7.}

\item{max.cpgs}{A single integer >= 1. All AMRs containing more than
`max.cpgs` genomic locations are filtered out. The default: `Inf`.}

\item{min.width}{A single integer >= 1 (the default). Only AMRs with the
width of at least `min.width` are returned.}

\item{dbeta}{A single non-negative numeric value in the range [0,1] or a
numeric vector of such values (with as many elements as there are AMRs).
Used to populate the `dbeta` metadata column, defines a desired absolute
deviation of corresponding AMR from the median for the `simulateData`
function.}
}
\value{
The output is a `GRanges` object that contains a subset of
aberrantly methylated regions (AMRs) randomly selected from all the possible
AMRs for the provided `template.ranges` object. The following metadata
columns are included:
\itemize{
  \item `revmap` -- integer list of `template.ranges` genomic locations that
  are included in this AMR region
  \item `ncpg` -- number of `template.ranges` genomic locations within
  this AMR region
  \item `sample` -- an identifier of a sample to which
  corresponding AMR belongs
  \item `dbeta` -- equals to supplied `dbeta` parameter
}
}
\description{
`simulateAMR` returns a `GRanges` object containing a set of randomly
selected aberrantly methylated regions (AMRs) to be used as an input for the
`simulateData` method.
}
\details{
Using provided template (`GRanges` object) `simulateAMR` randomly selects
genomic regions satisfying various criteria (number of CpGs, width of the
region) and assigns them to samples according to specified parameters
(number of AMRs per sample, number of samples per AMR). Its output is meant
to be used as the set of true positive AMRs for the `simulateData` function.
}
\examples{
  data(ramr)
  set.seed(1)
  amrs.unique <-
    simulateAMR(ramr.data, nsamples=4, regions.per.sample=2,
                min.cpgs=5, merge.window=1000, dbeta=0.2)
  amrs.nonunique <-
    simulateAMR(ramr.data, nsamples=3, exclude.ranges=amrs.unique,
                samples.per.region=2, min.cpgs=5, merge.window=1000)
}
\seealso{
\code{\link{simulateData}} for the generation of simulated test
data sets, \code{\link{getAMR}} for identification of AMRs,
\code{\link{plotAMR}} for plotting AMRs, \code{\link{getUniverse}}
for info on enrichment analysis, and `ramr` vignettes for the description of
usage and sample data.
}
